unit Tri;

interface
const
   MaxObj = 1000000;
type
   key = record
      rang : longint;
      value : string;
   end;
   T_Table = array[0..MaxObj] of key;
   P_Table = ^T_Table;
procedure SortTable(les_chiffres : P_Table; nombre : longint);

implementation


const
   MaxRecur = 10000;
   Tabulation = #9;

procedure SortTable(les_chiffres : P_Table; nombre : longint);
Var
   s, sj, sl, sr, j,S1,resa_rang : LongInt;        // les compteurs intermediaires  du tri
   Code: string;                       // Clef de recherche
   Resa_Chiffre: string;               // Utiliser pour les permutation doit etre du mme type que la donnee trie
   St: Array[0..MaxRecur, 0..1] Of LongInt;  // Table qui remplace la recursivit et amliore CONSIDERABLEMENT les performances
                                        // le dimensionnement  100 correspond au nombre maximal d'appel en recursivit
                                        // normalement 10 devraient suffir mais avec 100 on doit pouvoir trier quelque milliards d'infos...
Begin
     S := 1;                            // IMPORTANT je ne trie pas l'lment ZERO
     st[S, 0] := 1;                     // Il suffit normalement de metrre S  zero pour le trier
     st[S, 1] := nombre;                 // Nombre d'elements  trier
     Repeat
       sl := st[S, 0];                  // Sauvegarde des offsets pour la recursivit
       sr := st[S, 1];
       S := pred(S);
       Repeat
         j := sl;                       // le quick sort trie le fichier par morceau de plus en plus grands
         sj := sr;
         S1 := (sl + sr) Div 2;            //  on divise le nombre d'elements choisi par deux
         Code := Les_Chiffres^[S1].value;  // On mmorise le criter de tri de l'elemnt actif (plus de xclarte dans les tests  suivre
         Repeat
           While (Les_Chiffres^[J].value < Code) Do   // Partant du debut de la portion selectionne on, recherche le p
             j := j + 1;                               // premier element plus grand dans cet interval
           While (Code < Les_Chiffres^[Sj].value) Do  // maintenant on recherchje le plus petit partant de la fin
             SJ := Sj - 1;
           If j <= sj Then                            // quand on a trouve on permute avec resa_Chiffre
            Begin                                     // l'autre concept du quick sort est que plus la  permutation est
              Resa_Chiffre := Les_Chiffres^[Sj].value;  // lointaine plus elle est efficace: il vaut mieux permuter le premier
              Resa_rang := Les_Chiffres^[Sj].rang;
              Les_Chiffres^[Sj].value := Les_Chiffres^[j].value;        // avec le dernier que le premier avec le second
              Les_Chiffres^[Sj].rang := Les_Chiffres^[j].rang;
              Les_Chiffres^[j].value := Resa_Chiffre;    // il a plus de chance d'tre  sa place
              Les_Chiffres^[j].rang := Resa_rang;
              j := Succ(J);                           // Je laisse les mathmaticiens le dmontrer....
              sj := Pred(sj);                         // on retrecie la portion de recherche jusqu'a son arrive  0 elements
            End;
         Until j > sj;
         If j < sr Then                               // Et c'est la qu'on recursive en se servant de la table
           Begin
             S := Succ(S);
             St[S, 0] := j;
             St[S, 1] := sr;
           End;
         sr := sj;
       until sl >= sr;
     Until S < 1;
End;                                                  // et la c'est FINI

end.
 