unit Unit1;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms,
  QDialogs, QStdCtrls, QComCtrls, IdBaseComponent, IdComponent,
  IdTCPConnection, IdTCPClient, IdFTP, QGrids, Math, QExtCtrls,StrUtils,
  IdAntiFreezeBase, IdAntiFreeze, QButtons, QMenus, temps,ephemerides;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabFichier: TTabSheet;
    Label2: TLabel;
    fichier_lowell: TEdit;
    ButtonFileLowellSeek: TButton;
    ButtonCreeBaseLowell: TButton;
    Orbite: TTabSheet;
    Label1: TLabel;
    ButtonFTPLowell: TButton;
    Button4: TButton;
    Label3: TLabel;
    OpenDialog1: TOpenDialog;
    l_compteur: TLabel;
    ScrollBar1: TScrollBar;
    StringGrid1: TStringGrid;
    SB_Min: TLabel;
    SB_Max: TLabel;
    SB_current: TLabel;
    Filtrage: TTabSheet;
    Label4: TLabel;
    ButtonAucunFiltre: TButton;
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    RadioButtonHSup: TRadioButton;
    RadioButtonHInf: TRadioButton;
    FiltreH: TEdit;
    Label5: TLabel;
    CheckBoxH: TCheckBox;
    CheckBoxDiam: TCheckBox;
    GroupBox2: TGroupBox;
    RadioButtonDiamSup: TRadioButton;
    FiltreDiam: TEdit;
    RadioButtonDiamInf: TRadioButton;
    CheckBoxIncl: TCheckBox;
    GroupBox3: TGroupBox;
    RadioButtonInclSup: TRadioButton;
    FiltreIncl: TEdit;
    RadioButtonInclInf: TRadioButton;
    CheckBoxExc: TCheckBox;
    GroupBox4: TGroupBox;
    RadioButtonExcSup: TRadioButton;
    FiltreExc: TEdit;
    RadioButtonExcInf: TRadioButton;
    CheckBoxDGA: TCheckBox;
    GroupBox5: TGroupBox;
    RadioButtonDGASup: TRadioButton;
    FiltreDGA: TEdit;
    RadioButtonGDAInf: TRadioButton;
    ButtonAppliquerFiltre: TButton;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Panel2: TPanel;
    CheckBoxCodeLowell: TCheckBox;
    TabSheet1: TTabSheet;
    Fichier_MPC: TEdit;
    Label11: TLabel;
    Label12: TLabel;
    ButtonFileMPCSeek: TButton;
    ButtonCreeBaseMPC: TButton;
    ButtonHTTPMPC: TButton;
    ComboBox1: TComboBox;
    Button1: TButton;
    Shape1: TShape;
    LabelSelection: TLabel;
    Label13: TLabel;
    ScrollBar2: TScrollBar;
    ScrollBar3: TScrollBar;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    TabSheet2: TTabSheet;
    Label18: TLabel;
    LabelNom: TLabel;
    LabelNumero: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    LabelVRang: TLabel;
    LabelVNom: TLabel;
    LabelVNumero: TLabel;
    LabelVH: TLabel;
    LabelVBMV: TLabel;
    LabelVClassIRAS: TLabel;
    LabelVDiam: TLabel;
    LabelVAnomMoy: TLabel;
    Label37: TLabel;
    LabelVEpoque: TLabel;
    LabelVArgPer: TLabel;
    LabelVLongNod: TLabel;
    LabelVInclin: TLabel;
    LabelVDGA: TLabel;
    LabelVExcent: TLabel;
    LabelVCode1: TLabel;
    LabelVCode2: TLabel;
    LabelVCode4: TLabel;
    LabelVCode3: TLabel;
    LabelVCode5: TLabel;
    LabelVCode6: TLabel;
    Label38: TLabel;
    Label39: TLabel;
    Label40: TLabel;
    Label41: TLabel;
    Recherche: TTabSheet;
    Edit1: TEdit;
    Label42: TLabel;
    Label43: TLabel;
    Button2: TButton;
    LMessage: TLabel;
    LMessage2: TLabel;
    Label44: TLabel;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    BUp: TBitBtn;
    BDown: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn1: TBitBtn;
    BitBtnSauveListe: TBitBtn;
    BitBtnEffaceListe: TBitBtn;
    Label45: TLabel;
    Label46: TLabel;
    BitBtn5: TBitBtn;
    PopupMenu1: TPopupMenu;
    PopupTable: TMenuItem;
    VoirElements1: TMenuItem;
    Label47: TLabel;
    StringGrid2: TStringGrid;
    TabSheet5: TTabSheet;
    Memo1: TMemo;
    Label48: TLabel;
    SaveDialog1: TSaveDialog;
    Label49: TLabel;
    Image1: TImage;
    PopupMenu2: TPopupMenu;
    Up1: TMenuItem;
    Effacer1: TMenuItem;
    Descendre1: TMenuItem;
    VoirElements2: TMenuItem;
    CB_Jour: TComboBox;
    CB_Mois: TComboBox;
    SE_Annee: TSpinEdit;
    Label50: TLabel;
    Label51: TLabel;
    SpinEdit2: TSpinEdit;
    Label52: TLabel;
    Label53: TLabel;
    SpinEdit3: TSpinEdit;
    ComboBox4: TComboBox;
    Memo2: TMemo;
    Aujourdhui: TBitBtn;
    CalculEphem: TBitBtn;
    SE_Heure: TSpinEdit;
    Label54: TLabel;
    SE_minute: TSpinEdit;
    Label55: TLabel;
    BMaintenant: TButton;
    Minuit: TButton;
    TabObservatoire: TTabSheet;
    Image2: TImage;
    LLongitude: TLabel;
    LLatitude: TLabel;
    Label56: TLabel;
    Label57: TLabel;
    Label58: TLabel;
    Label59: TLabel;
    SpinAltitude: TSpinEdit;
    CheckBox2: TCheckBox;
    Label60: TLabel;
    CB_Observatoire: TComboBox;
    BGeocentrique: TButton;
    Label61: TLabel;
    CB_UAI: TComboBox;
    LabelUAI: TLabel;
    ComboBox5: TComboBox;
    Label62: TLabel;
    Label63: TLabel;
    Label25: TLabel;
    CBLangue: TComboBox;
    Label64: TLabel;
    BitBtn3: TBitBtn;
    Label65: TLabel;
    BEncke: TButton;
    BSaveLog: TButton;
    TabSheet6: TTabSheet;
    NomFichierRapportMPC: TEdit;
    Label66: TLabel;
    BRapportMPC: TButton;
    BAnalyseMesures: TButton;
    Memo3: TMemo;
    Label67: TLabel;
    CheckBoxATEN: TCheckBox;
    CheckBoxAPOLLO: TCheckBox;
    CheckBoxAMOR: TCheckBox;
    CheckBoxCROISEUR: TCheckBox;
    CheckBoxMPC1: TCheckBox;
    Label68: TLabel;
    CheckBoxMPC2: TCheckBox;
    CheckBoxMPC3: TCheckBox;
    CheckBoxMPC4: TCheckBox;
    CheckBoxMPC5: TCheckBox;
    CheckBoxMPC6: TCheckBox;
    CheckBoxMPC7: TCheckBox;
    ButtonCodeTous: TButton;
    Label69: TLabel;
    CheckBoxLowell5: TCheckBox;
    CheckBoxLowell6: TCheckBox;
    CheckBoxLowell7: TCheckBox;
    CheckBoxLowell8: TCheckBox;
    CheckBoxLowell9: TCheckBox;
    CheckBoxLowell10: TCheckBox;
    ButtonCodeAucun: TButton;
    Label70: TLabel;
    Label71: TLabel;
    CheckBoxSurveyPLS: TCheckBox;
    CheckBoxSurveyT1: TCheckBox;
    CheckBoxSurveyT2: TCheckBox;
    CheckBoxSurveyT3: TCheckBox;
    CheckBoxSurveyUCAS: TCheckBox;
    Label72: TLabel;
    ButtonToutCalculer: TButton;
    ButtonCalculerToutOpt: TButton;
    CheckBoxMPCTroyen: TCheckBox;
    CheckBoxCodeMPC: TCheckBox;
    CheckBoxMPCAten: TCheckBox;
    CheckBoxMPCApollo: TCheckBox;
    CheckBoxMPCAmor: TCheckBox;
    CheckBoxMPCCentaure: TCheckBox;
    CheckBoxMPCPlutino: TCheckBox;
    CheckBoxMPCTNOR: TCheckBox;
    CheckBoxMPCCubewano: TCheckBox;
    CheckBoxMPCPHA: TCheckBox;
    CheckBoxMPCNew: TCheckBox;
    CheckBoxMPCCritique: TCheckBox;
    procedure Button4Click(Sender: TObject);
    procedure ButtonFileLowellSeekClick(Sender: TObject);
    procedure ButtonCreeBaseLowellClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure ButtonAucunFiltreClick(Sender: TObject);
    procedure CheckBoxHClick(Sender: TObject);
    procedure SetAppliquerFiltre;
    procedure CheckBoxDiamClick(Sender: TObject);
    procedure CheckBoxInclClick(Sender: TObject);
    procedure CheckBoxExcClick(Sender: TObject);
    procedure CheckBoxDGAClick(Sender: TObject);
    procedure ButtonAppliquerFiltreClick(Sender: TObject);
    procedure Update_StringGrid1;
    procedure ButtonFileMPCSeekClick(Sender: TObject);
    procedure ButtonCreeBaseMPCClick(Sender: TObject);
    procedure StringGrid1Click(Sender: TObject);
    procedure ButtonFTPLowellClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Mise_a_jour_detail(objet_selectionne : longint);
    procedure Recherche_asteroide(Cle : string;Taille : longint; var resultat : longint;
                              var trouve   : boolean);
    procedure VoirElements1Click(Sender: TObject);
    procedure StringGrid1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PopupTableClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Ajout_objet(objet : longint);
    procedure BitBtnEffaceListeClick(Sender: TObject);
    procedure BitBtnSauveListeClick(Sender: TObject);
    procedure StringGrid2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Up1Click(Sender: TObject);
    procedure Descendre1Click(Sender: TObject);
    procedure Effacer1Click(Sender: TObject);
    procedure VoirElements2Click(Sender: TObject);
    procedure StringGrid2Click(Sender: TObject);
    procedure BUpClick(Sender: TObject);
    procedure BDownClick(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure AujourdhuiClick(Sender: TObject);
    procedure CalculEphemClick(Sender: TObject);
    procedure BMaintenantClick(Sender: TObject);
    procedure MinuitClick(Sender: TObject);
    procedure Image2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PageControl1Enter(Sender: TObject);
    procedure TabSheet5Enter(Sender: TObject);
    procedure CB_JourChange(Sender: TObject);
    procedure CB_MoisChange(Sender: TObject);
    procedure SE_AnneeChanged(Sender: TObject; NewValue: Integer);
    procedure SE_HeureChanged(Sender: TObject; NewValue: Integer);
    procedure SE_minuteChanged(Sender: TObject; NewValue: Integer);
    procedure CB_ObservatoireChange(Sender: TObject);
    procedure BGeocentriqueClick(Sender: TObject);
    procedure CB_UAIChange(Sender: TObject);
    procedure fichier_lowellChange(Sender: TObject);
    procedure ButtonCalculerToutOptClick(Sender: TObject);
    procedure Lecture_langue(fLangue : string);
    procedure CBLangueChange(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BEnckeClick(Sender: TObject);
    procedure BSaveLogClick(Sender: TObject);
    procedure BRapportMPCClick(Sender: TObject);
    procedure BAnalyseMesuresClick(Sender: TObject);
    procedure ButtonCodeTousClick(Sender: TObject);
    procedure ButtonCodeAucunClick(Sender: TObject);
    procedure CheckBoxCodeLowellClick(Sender: TObject);
    procedure CheckBoxATENClick(Sender: TObject);
    procedure CheckBoxAPOLLOClick(Sender: TObject);
    procedure CheckBoxAMORClick(Sender: TObject);
    procedure CheckBoxCROISEURClick(Sender: TObject);
    procedure CheckBoxMPC1Click(Sender: TObject);
    procedure CheckBoxMPC2Click(Sender: TObject);
    procedure CheckBoxMPC3Click(Sender: TObject);
    procedure CheckBoxMPC4Click(Sender: TObject);
    procedure CheckBoxMPC5Click(Sender: TObject);
    procedure CheckBoxMPC6Click(Sender: TObject);
    procedure CheckBoxMPC7Click(Sender: TObject);
    procedure CheckBoxLowell5Click(Sender: TObject);
    procedure CheckBoxLowell6Click(Sender: TObject);
    procedure CheckBoxLowell7Click(Sender: TObject);
    procedure CheckBoxLowell8Click(Sender: TObject);
    procedure CheckBoxLowell9Click(Sender: TObject);
    procedure CheckBoxLowell10Click(Sender: TObject);
    procedure CheckBoxSurveyPLSClick(Sender: TObject);
    procedure CheckBoxSurveyT1Click(Sender: TObject);
    procedure CheckBoxSurveyT2Click(Sender: TObject);
    procedure CheckBoxSurveyT3Click(Sender: TObject);
    procedure CheckBoxSurveyUCASClick(Sender: TObject);
    procedure ButtonToutCalculerClick(Sender: TObject);
    procedure DisabledMPCCheck;
    procedure DisableLowellCheck;
    procedure CheckBoxMPCAtenClick(Sender: TObject);
    procedure CheckBoxMPCApolloClick(Sender: TObject);
    procedure CheckBoxMPCAmorClick(Sender: TObject);
    procedure CheckBoxMPCPlutinoClick(Sender: TObject);
    procedure CheckBoxMPCTroyenClick(Sender: TObject);
    procedure CheckBoxMPCCentaureClick(Sender: TObject);
    procedure CheckBoxMPCTNORClick(Sender: TObject);
    procedure CheckBoxMPCCubewanoClick(Sender: TObject);
    procedure CheckBoxMPCPHAClick(Sender: TObject);
    procedure CheckBoxMPCNewClick(Sender: TObject);
    procedure CheckBoxMPCCritiqueClick(Sender: TObject);
    procedure CheckBoxCodeMPCClick(Sender: TObject);
    procedure ButtonHTTPMPCClick(Sender: TObject);

  private

    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

const
   max_liste = 500000;
   BSA       = 0.996647187;
   Rayon_Terre_Eq = 6378140.0; { Rayon Equatorial Terrestre en mtre }
type
{ Format FORTRAN du fichier astorb.dat :
A5,1X,A18,1X,A15,1X,A5,1X,F5.2,1X,A4,1X,A5,1X,A4, 1X,6I4,1X,
2I5,1X,I4,2I2.2,1X,3(F10.6,1X),F9.6,1X,F10.8, 1X,F12.8,1X,I4,2I2.2,1X,F7.2,1X,F8.2,1X,I4,2I2,3(1X,F7.2,1X,I4,2I2)
}
   T_orbiteAscii = record
      numero : string[7];
      nom : string[18];
      H : string[5];
      G : string[4];
      BMV : string[4];
      Diam : string[5];
      Iclass: string[4];
      Epoque : String[10];
      AnomMoy: string[10];
      ArgPer : string[10];
      LongNod :string[10];
      Inclin  :string[9];
      Excent  :string[10];
      DGA     :string[12];
      Code1,Code2,Code3,Code4,Code5,Code6 : string[4]
{
      DateComp : I4,2I2.2,1X
CEU    : F7.2,1X (current ephemeris uncertaincy)
CEUchg.: F8.2,1X
CEUdate: I4,2I2,
PEUdata: 3(1X,F7.2,1X,I4,2I2) (peak ephemeris uncertaincy
}

   end;
   P_orbiteAscii = ^T_orbiteAscii;
   T_mesure = record
       num_mes : string[6];
       obj_mes : string[10];
       instant_mes : double;
       AD_mes : double;
       DEC_mes : double;
       mag_mes : double;
   end;

var
  Form1: TForm1;
  liste : array[1..max_liste] of P_OrbiteAscii;
  liste_filtree : array[1..max_liste] of longint;
  taille_liste_filtree,taille_liste,stringGrid1_Debut,
  debut_actuel : longint;  { Rang de l'asteroide  la ligne 1 }
  selection_objet_selectionne_liste,   { Numero de l'asteroide selectionne dans la liste des selections }
  objet_selectionne_liste,        {Nombre d'objet dans la liste des asteroides selectionnes }
  {compteur_liste, } objet_selectionne : longint;
  ephem_date : T_date;
  {ephem_heure : real;}
  observatoire : T_Observatoire;
  liste_observatoire : array of T_Observatoire;
  nbre_observatoire,nbre_langue  : integer;
  NLangue : array[0..100] of string;
    _FormCreate,lecture_lowell,lecture_MPC : boolean;
  DemandeChargement : (DemandeChargementLowell,DemandeChargementMPC) ;

implementation

uses Unit2,Unit3, Tri,decoupe ;

var
   Table_tri      : P_Table;
   Table_msg      : array of string;
{$R *.xfm}

function char_alpha(c: char):integer;
begin
   case c of
   '0'..'9' : char_alpha:=Ord(c)-Ord('0');
   'A'..'V' : char_alpha:=Ord(c)-Ord('A')+10;
   end;
end;

procedure compact_to_date(c : string; var date : T_date; var erreur : boolean);
var
   code,a : integer;
begin
   c:=Trim(c);
   erreur:=false;
   with date do
   begin
      case c[1] of
      'I' : annee:=1800;
      'J' : annee:=1900;
      'K' : annee:=2000;
      'L' : annee:=2100;
      else erreur:=true;
      end;
      Val(c[2]+c[3],a,code);
      if code=0 then annee:=annee+a else erreur:=true;
      if c[4] in ['0'..'9','A','B','C'] then mois:=char_alpha(c[4]) else erreur:=true;
      if c[5] in ['0'..'9','A'..'V'] then jour:=char_alpha(c[5]) else erreur:=true;
   end;
end;

procedure TForm1.Lecture_langue(fLangue : string);
var
   f : textfile;
   b : string;
   nb_ligne,k,index : integer;
   mots             : T_phrase;

begin
 {$I-}
   assignfile(f,fLangue);
   reset(f);
 {$I-}
   nb_ligne:=0;
   repeat
      readln(f);
      inc(nb_ligne);
   until eof(f);
   reset(f);
   SetLength(Table_Msg,nb_ligne);
   repeat
      readln(f,b);
      if b[1]+b[2]<>'//' then
      begin
         decouper(b,':',mots);
         Val(mots[1],index,k);
         if k=0 then Table_Msg[index]:=mots[2]+mots[3]+mots[4]+mots[5]+mots[6]+mots[7]+mots[8];
      end;
   until eof(f);
   closefile(f);

   TabFichier.Caption:=Table_Msg[1];
   Recherche.Caption:=Table_Msg[2];
   Filtrage.Caption:=Table_Msg[3];
   Orbite.Caption:=Table_Msg[4];
   TabSheet2.Caption:=Table_Msg[5];
   TabSheet3.Caption:=Table_Msg[6];
   TabSheet5.Caption:=Table_Msg[7];
   TabObservatoire.Caption:=Table_Msg[8];
   TabSheet1.Caption:=Table_Msg[9];
   TabSheet4.Caption:=Table_Msg[10];
   Label2.Caption:=Table_Msg[11];
   ButtonFTPLowell.Caption:=Table_Msg[12];
   Label38.Caption:=Table_Msg[13];
   Label3.Caption:=Table_Msg[14];
   Label12.Caption:=Table_Msg[14];
   ButtonCreeBaseLowell.Caption:=Table_Msg[15];
   ButtonCreeBaseMPC.Caption:=Table_Msg[15];
   Button1.Caption:=Table_Msg[16];
   Label11.Caption:=Table_Msg[17];
   Button4.Caption:=Table_Msg[18];
   Label64.Caption:=Table_Msg[19];
   Label42.Caption:=Table_Msg[20];
   Label43.Caption:=Table_Msg[21];
   Button2.Caption:=Table_Msg[22];
   Label4.Caption:=Table_Msg[23];
   ButtonAucunFiltre.Caption:=Table_Msg[24];
   Label5.Caption:=Table_Msg[25];
   RadioButtonDiamSup.Caption:=Table_Msg[26]+' >';
   RadioButtonDiamInf.Caption:='> '+Table_Msg[26];
   RadioButtonInclSup.Caption:=Table_Msg[27]+' >';
   RadioButtonInclInf.Caption:='> '+Table_Msg[27];
   RadioButtonExcSup.Caption:=Table_Msg[28]+' >';
   RadioButtonExcInf.Caption:='> '+Table_Msg[28];
   RadioButtonDGASup.Caption:=Table_Msg[29]+' >';
   RadioButtonGDAInf.Caption:='> '+Table_Msg[29];
   CheckBoxCodeLowell.Caption:=Table_Msg[30];
   ButtonAppliquerFiltre.Caption:=Table_Msg[31];
   Label6.Caption:=Table_Msg[32];
   Label7.Caption:=Table_Msg[32];
   Label8.Caption:=Table_Msg[32];
   Label9.Caption:=Table_Msg[32];

   Label18.Caption:=Table_Msg[37];
   Label22.Caption:=Table_Msg[38]+' :';
   Label21.Caption:=Table_Msg[39]+' :';
   Label23.Caption:=Table_Msg[40];
   Label24.Caption:=Table_Msg[41]+' :';
   Label25.Caption:=Table_Msg[42]+' :';
   LabelNom.Caption:=Table_Msg[33]+' :';
   LabelNumero.Caption:=Table_Msg[34]+' :';
   Label37.Caption:=Table_Msg[35]+' :';

   Label29.Caption:=Table_Msg[29]+' (UA):';
   Label28.Caption:=Table_Msg[28]+' :';
   Label27.Caption:=Table_Msg[27]+' ():';
   Label26.Caption:=Table_Msg[44]+' :';
   BitBtn1.Caption:=Table_Msg[43];

   Label30.Caption:=Table_Msg[45];
   Label31.Caption:=Table_Msg[46]+' :';
   Label32.Caption:=Table_Msg[47]+' :';
   Label33.Caption:=Table_Msg[48]+' :';
   Label34.Caption:=Table_Msg[49]+' :';
   Label35.Caption:=Table_Msg[50]+' :';
   Label36.Caption:=Table_Msg[51]+' :';

   Label47.Caption:=Table_Msg[61];
   Label45.Caption:=Table_Msg[62]+' :';
   Label46.Caption:=Table_Msg[63]+' :';
   BitBtnEffaceListe.Caption:=Table_Msg[64];

   Label50.Caption:=Table_Msg[7];
   Label51.Caption:=Table_Msg[67]+' :';
   Label52.Caption:=Table_Msg[68]+':';
   Label53.Caption:=Table_Msg[69]+':';
   Aujourdhui.Caption:=Table_Msg[70];
   BMaintenant.Caption:=Table_Msg[71];
   Minuit.Caption:=Table_Msg[72];
   Checkbox2.Caption:=Table_Msg[73];
   CalculEphem.Caption:=Table_Msg[74];
   Label62.Caption:=Table_Msg[75];
   Combobox4.Items[1]:=Table_Msg[76];
   Combobox4.Items[0]:=Table_Msg[77];


   Label57.Caption:=Table_Msg[81];
   Label60.Caption:=Table_Msg[82];
   Label61.Caption:=Table_Msg[83];
   Label56.Caption:=Table_Msg[84]+':';
   Label58.Caption:=Table_Msg[85]+':';
   Label59.Caption:=Table_Msg[86]+':';
   BGeocentrique.Caption:=Table_Msg[87];

   Label44.Caption:=Table_Msg[91];
   Label48.Caption:=Table_Msg[80];

   PopupMenu1.Items[0].Caption:=Table_Msg[100];
   PopupMenu1.Items[1].Caption:=Table_Msg[101];
   PopupMenu2.Items[0].Caption:=Table_Msg[106];
   PopupMenu2.Items[1].Caption:=Table_Msg[107];
   PopupMenu2.Items[2].Caption:=Table_Msg[108];
   PopupMenu2.Items[3].Caption:=Table_Msg[109];

   LMessage2.Caption:='';

 {$I-}
   Memo1.Clear;
   flangue:=AnsiReplaceStr(flangue,'msg','intro');
   assignfile(f,fLangue);
   reset(f);
 {$I-}
   repeat
       readln(f,b);
       memo1.Append(b);
   until eof(f);
   closefile(f);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
   Dispose(Table_Tri);
   Close;
end;

procedure TForm1.ButtonFileLowellSeekClick(Sender: TObject);
begin
   Opendialog1.InitialDir:=ExtractFileDir(fichier_lowell.Text);
   if Opendialog1.Execute then
      If FileExists(Opendialog1.FileName) then
      begin
         fichier_lowell.Text:=Opendialog1.FileName;
         ButtonCreeBaseLowell.Enabled:=true;
      end
      else
      begin
         fichier_lowell.Text:='';
         ButtonCreeBaseLowell.Enabled:=false;
      end;
end;

procedure TForm1.Update_StringGrid1;
var
   li : longint;
   s  : string;
begin
   for li:=debut_actuel to min(1000,taille_liste_filtree-StringGrid1_debut+1) do
   begin
      Str(li,s);
      StringGrid1.Cells[ 0,li]:=s;
      StringGrid1.Cells[ 1,li]:=liste[liste_filtree[li]]^.numero;
      StringGrid1.Cells[ 2,li]:=liste[liste_filtree[li]]^.nom;
      StringGrid1.Cells[ 3,li]:=liste[liste_filtree[li]]^.H ;
      StringGrid1.Cells[ 4,li]:=liste[liste_filtree[li]]^.BMV ;
      StringGrid1.Cells[ 5,li]:=liste[liste_filtree[li]]^.Diam;
      StringGrid1.Cells[ 6,li]:=liste[liste_filtree[li]]^.Epoque ;
      StringGrid1.Cells[ 7,li]:=liste[liste_filtree[li]]^.AnomMoy;
      StringGrid1.Cells[ 8,li]:=liste[liste_filtree[li]]^.ArgPer;
      StringGrid1.Cells[ 9,li]:=liste[liste_filtree[li]]^.LongNod;
      StringGrid1.Cells[10,li]:=liste[liste_filtree[li]]^.Inclin;
      StringGrid1.Cells[11,li]:=liste[liste_filtree[li]]^.Excent ;
      StringGrid1.Cells[12,li]:=liste[liste_filtree[li]]^.DGA;
   end;
   StringGrid1.RowCount:=min(1000,taille_liste_filtree-StringGrid1_debut+1)+1;

end;


procedure TForm1.ButtonCreeBaseLowellClick(Sender: TObject);
var
   astorb : textfile;
   buffer : string;
   compteur : longint;
   s,s1,s2  : string;
begin
   If FileExists(Fichier_lowell.text) then
   begin
      AssignFile(astorb,Fichier_lowell.text);
      Reset(astorb);
      compteur:=0;
      LMessage.Caption:=Table_Msg[110];
      repeat
         readln(astorb,buffer);
         if buffer<>'' then
         begin
             inc(compteur);
             new(liste[compteur]);
             with liste[compteur]^ do
             begin
                numero:=copy(buffer,1,6);
                str(compteur,s);
                nom:=copy(buffer,8,18);
                with Table_Tri[2*compteur-1] do
                begin
                   rang:=compteur;
                   Str(compteur,value);
                end;
                with Table_Tri[2*compteur] do
                begin
                   rang:=compteur;
                   value:=Trim(nom);
                end;
                H:=copy(buffer,43,5);
                G:=copy(buffer,50,4);
                BMV:=copy(buffer,55,4);
                diam:=copy(buffer,60,5);
                IClass:=copy(buffer,66,4);
                Code1:=copy(buffer,71,4);
                Code2:=copy(buffer,75,4);
                Code3:=copy(buffer,79,4);
                Code4:=copy(buffer,83,4);
                Code5:=copy(buffer,87,4);
                Code6:=copy(buffer,91,4);

                s1:=copy(buffer,107,4);
                s2:=copy(buffer,111,2);
                Epoque:=copy(buffer,113,2)+'/'+s2+'/'+s1;
                AnomMoy:=copy(buffer,116,10);
                ArgPer:=copy(buffer,127,10);
                LongNod:=copy(buffer,138,10);
                Inclin:= copy(buffer,149,9);
                Excent:= copy(buffer,159,10);
                DGA:=copy(buffer,170,12);
             end;
             Liste_Filtree[compteur]:=compteur;
         end;
      until eof(astorb);
      closefile(astorb);
      s:='';
      LMessage.Caption:=Table_Msg[111]; {'Tri des objets de la base de Lowell';}

      SortTable(Table_Tri,2*compteur);
      LMessage.Caption:=Table_Msg[112];

      taille_liste:=compteur;
      taille_liste_filtree:=compteur;

      StringGrid1.RowCount:=1001;
      str(compteur,s);
      l_compteur.Caption:=s+' '+Table_Msg[113];
      SB_Max.Caption:=s;
      Orbite.TabVisible:=true;
      With Scrollbar1 do
      begin
         Max:=compteur;
         SmallChange:=1000;
      end;
      debut_actuel:=1;

      Update_StringGrid1;

      ButtonFileLowellSeek.Enabled:=false;
      ButtonCreeBaseLowell.Enabled:=false; { Ainsi, si le fichier est lu, on ne peut plus
                                  recrer la liste }
      ButtonFileMPCSeek.Enabled:=false;
      ButtonCreeBaseMPC.Enabled:=false;

      Orbite.Enabled:=true;
      Filtrage.Enabled:=true;
      StringGrid1.Visible:=true;
      TabSheet6.Enabled:=True;
      Lecture_lowell:=true;
      Lecture_MPC:=false;
      DisabledMPCCheck;
   end;

{ Format FORTRAN du fichier astorb.dat :
Number : A5,1X    A6,1X depuis Octobre 2005 (passage des 100000 ast.)
Nom    : A18,1X
O.comp.: A15,1X
H      : A5,1X
Slope  : F5.2,1X
B-V    : A4,1X
I diam : A5,1X
I class: A4, 1X,
type   : 6I4,1X,
O.Arc+NObs :2I5,1X,
Epoque : I4,2I2.2,1X,
AnomMoy,ArgPer,LongNod : 3(F10.6,1X),
Inclin.: F9.6,1X,
Excent.: F10.8, 1X,
DGA    : F12.8,1X
DateComp : I4,2I2.2,1X
CEU    : F7.2,1X (current ephemeris uncertaincy)
CEUchg.: F8.2,1X
CEUdate: I4,2I2,
PEUdata: 3(1X,F7.2,1X,I4,2I2) (peak ephemeris uncertaincy
}
end;

procedure TForm1.DisabledMPCCheck;
begin
   CheckboxCodeMPC.Enabled:=false;
   CheckBoxMPCAten.Enabled:=false;
   CheckBoxMPCAmor.Enabled:=false;
   CheckBoxMPCApollo.Enabled:=false;
   CheckBoxMPCPlutino.Enabled:=false;
   CheckBoxMPCTroyen.Enabled:=false;
   CheckBoxMPCCentaure.Enabled:=false;
   CheckBoxMPCTNOR.Enabled:=false;
   CheckBoxMPCCubewano.Enabled:=false;
   CheckBoxMPCPHA.Enabled:=false;
   CheckBoxMPCNew.Enabled:=false;
   CheckBoxMPCCritique.Enabled:=false;
end;

procedure TForm1.DisableLowellCheck;
begin
    checkBoxCodeLowell.Enabled:=False;
    CheckBoxAten.Enabled:=false;
    CheckBoxAPOLLO.Enabled:=false;
    CheckBoxAMOR.Enabled:=false;
    CheckBoxCROISEUR.Enabled:=false;
    CheckBoxMPC1.Enabled:=false;
    CheckBoxMPC2.Enabled:=false;
    CheckBoxMPC3.Enabled:=false;
    CheckBoxMPC4.Enabled:=false;
    CheckBoxMPC5.Enabled:=false;
    CheckBoxMPC6.Enabled:=false;
    CheckBoxMPC7.Enabled:=false;

    CheckBoxLowell5.Enabled:=false;
    CheckBoxLowell6.Enabled:=false;
    CheckBoxLowell7.Enabled:=false;
    CheckBoxLowell8.Enabled:=false;
    CheckBoxLowell9.Enabled:=false;
    CheckBoxLowell10.Enabled:=false;

    CheckBoxSurveyPLS.Enabled:=false;
    CheckBoxSurveyT1.Enabled:=false;
    CheckBoxSurveyT2.Enabled:=false;
    CheckBoxSurveyT3.Enabled:=false;
    CheckBoxSurveyUCAS.Enabled:=false;
    Label68.Enabled:=false;
    Label69.Enabled:=false;
    Label71.Enabled:=false;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
   t             : TextFile;
   buffer,Langue : string;
   phi,u         : real;
   k,ck          : integer;
   {mots          : T_phrase;}
begin
   _FormCreate:=True;
 {$I-}
   assignfile(t,'.tdcrc');
   reset(t);
 {$I-}
   Repeat
      readln(t,Langue);
   until Langue[1]<>'/';
   k:=0;
   CBLangue.MaxItems:=-1;
   repeat
      readln(t,buffer);
      if buffer[1]<>'/' then
      begin
         NLangue[k]:=buffer;
         inc(k);
      end;
   until eof(t);
   Nbre_Langue:=k;
   CBLangue.MaxItems:=k;
   for ck:=0 to k-1 do
      CBLangue.Items[ck]:=NLangue[ck];
   closefile(t);
   Lecture_langue('tdc_msg_'+Langue+'.txt'); //  dfinir dans un fichier .ini
   CBLangue.Text:=Langue;
   StringGrid1.Cells[ 0,0]:='#';
   StringGrid1.Cells[ 1,0]:=Table_Msg[34];
   StringGrid1.Cells[ 2,0]:=Table_Msg[33];
   StringGrid1.Cells[ 3,0]:='H';
   StringGrid1.Cells[ 4,0]:='B-V';
   StringGrid1.Cells[ 5,0]:='Diam';
   StringGrid1.Cells[ 6,0]:=Table_Msg[35];
   StringGrid1.Cells[ 7,0]:='Ano.Moy.';
   StringGrid1.Cells[ 8,0]:='Arg.Per.';
   StringGrid1.Cells[ 9,0]:='Long.Nd.';
   StringGrid1.Cells[10,0]:='i ()';
   StringGrid1.Cells[11,0]:='e';
   StringGrid1.Cells[12,0]:='a (UA)';
   StringGrid1.Cells[13,0]:=Table_Msg[36];

   StringGrid1.ColWidths[1]:=80;  { DONE : Mettre une largeur correspondant au code compact complet }
   StringGrid1.ColWidths[2]:=150;
   StringGrid1.ColWidths[3]:=50;
   StringGrid1.ColWidths[4]:=50;
   StringGrid1.ColWidths[5]:=50;
   StringGrid1.ColWidths[6]:=90;
   StringGrid1.ColWidths[7]:=90;
   StringGrid1.ColWidths[8]:=90;
   StringGrid1.ColWidths[9]:=90;
   StringGrid1.ColWidths[10]:=90;
   StringGrid1.ColWidths[11]:=95;
   StringGrid1.ColWidths[12]:=100;
   StringGrid1.ColWidths[13]:=90;


   StringGrid2.Cells[ 0,0]:='#';
   StringGrid2.Cells[ 1,0]:=Table_Msg[34];
   StringGrid2.Cells[ 2,0]:=Table_Msg[33];
   StringGrid2.ColWidths[2]:=150;

   LMessage.Caption:='';
   Orbite.Enabled:=false;
   Filtrage.Enabled:=false;
   StringGrid1.Visible:=false;
   New(Table_tri);
   objet_selectionne_liste:=0;

   AujourdhuiClick(sender);
   MinuitClick(Sender);

   With Observatoire do { Cas gocentrique par dfaut : }
   begin
      Latitude:=0;
      Longitude:=0;
      Altitude:=0;
      RhoCosPhip:=0;
      RhoSinPhiP:=0;
   end;

   ComboBox4.ItemIndex:=0;
   ButtonCreeBaseLowell.Enabled:=FileExists(fichier_Lowell.Text);
 {$I-}
   assignfile(t,'observat.loc');
   reset(t);
 {$I-}
   if IOResult=0 then
   begin
      SetLength(Liste_Observatoire,2000);
      Readln(t,buffer);
      nbre_observatoire:=0;
      CB_Observatoire.MaxItems:=9000;
      repeat
         if not eof(t) then
         begin
            Readln(t,buffer);
            inc(nbre_observatoire);
        { Cf Astronomie Pratique et Informatique pp 20-21 }
            with Liste_Observatoire[nbre_observatoire] do
            begin
               code:=copy(buffer,1,3);
               nom:=copy(buffer,31,40);
               Val(Trim(copy(buffer,5,9)),longitude,k);
               ck:=k;
               Val(Trim(Copy(buffer,22,9)),rhosinphip,k);
               ck:=ck+k;
               Val(Trim(Copy(buffer,14,8)),rhocosphip,k);
               ck:=ck+k;
               if (ck=0) and (rhocosphip>0) then  { Pas de donne manquante }
               begin
                  u:=Arctan(rhosinphip/rhocosphip/BSA);
                  Phi:=Arctan(Rhosinphip/rhocosphip/BSA/BSA);
                  Altitude:=Rayon_Terre_Eq*(rhocosphip-cos(u))/cos(Phi);
                  Latitude:=ArcTan(rhosinphip/rhocosphip);  {Latitude gographique du lieu}
                  longitude:=longitude/180*pi;
      {            Latitude:=Arctan(sinus/cosinus)*0.996647187;} { Latitude gocentrique }
                  CB_Observatoire.Items.Insert(nbre_observatoire,nom);
                  CB_UAI.Items.Insert(nbre_observatoire,code);     {Liste des codes UAI}
               end
               else Dec(nbre_observatoire);
            end;
         end;
      until eof(t);
      closefile(t);
   end;
   _FormCreate:=False;
   Lecture_MPC:=false;
   Lecture_Lowell:=false;
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
var
   s: string;
   li : longint;
begin
    StringGrid1_debut:=(scrollbar1.Position div 1000)*1000+1;
    str(StringGrid1_debut,s);

    SB_current.Caption:=s;

    if StringGrid1_debut<>debut_actuel then
    begin
       StringGrid1.RowCount:=min(1000,taille_liste_filtree-StringGrid1_debut+1)+1;
       for li:=1 to min(1000,taille_liste_filtree-StringGrid1_debut+1) do
       begin
         Str(StringGrid1_debut+li-1,s);
         StringGrid1.Cells[ 0,li]:=s;
         StringGrid1.Cells[ 1,li]:=liste[liste_filtree[StringGrid1_debut-1+li]]^.numero;
         StringGrid1.Cells[ 2,li]:=liste[liste_filtree[StringGrid1_debut-1+li]]^.nom;
         StringGrid1.Cells[ 3,li]:=liste[liste_filtree[StringGrid1_debut-1+li]]^.H ;
         StringGrid1.Cells[ 4,li]:=liste[liste_filtree[StringGrid1_debut-1+li]]^.BMV ;
         StringGrid1.Cells[ 5,li]:=liste[liste_filtree[StringGrid1_debut-1+li]]^.Diam;
         StringGrid1.Cells[ 6,li]:=liste[liste_filtree[StringGrid1_debut-1+li]]^.Epoque ;
         StringGrid1.Cells[ 7,li]:=liste[liste_filtree[StringGrid1_debut-1+li]]^.AnomMoy;
         StringGrid1.Cells[ 8,li]:=liste[liste_filtree[StringGrid1_debut-1+li]]^.ArgPer;
         StringGrid1.Cells[ 9,li]:=liste[liste_filtree[StringGrid1_debut-1+li]]^.LongNod;
         StringGrid1.Cells[10,li]:=liste[liste_filtree[StringGrid1_debut-1+li]]^.Inclin;
         StringGrid1.Cells[11,li]:=liste[liste_filtree[StringGrid1_debut-1+li]]^.Excent ;
         StringGrid1.Cells[12,li]:=liste[liste_filtree[StringGrid1_debut-1+li]]^.DGA;

{    SB_new.caption:=s;      }
       end;
       debut_actuel:=StringGrid1_debut;
    end;

end;

procedure TForm1.ButtonAucunFiltreClick(Sender: TObject);
var
   li : longint;
   s  : string;
begin
   CheckBoxH.Checked:=false;
   CheckBoxDiam.Checked:=false;
   CheckBoxIncl.Checked:=false;
   CheckBoxExc.Checked:=false;
   CheckBoxDGA.Checked:=false;
   CheckBoxCodeLowell.Checked:=false;

   ButtonCodeAucunClick(sender);

   Taille_liste_filtree:=Taille_liste;
   for li:=1 to Taille_liste do
      Liste_Filtree[li]:=li;

   str(Taille_liste,s);
   SB_Max.Caption:=s;
   Scrollbar1.Max:=Taille_liste;

   Update_StringGrid1;
end;

procedure TForm1.SetAppliquerFiltre;
begin
   ButtonAppliquerFiltre.Enabled:=CheckBoxH.Checked or
     CheckBoxDiam.Checked or CheckBoxIncl.Checked or
     CheckBoxExc.Checked  or CheckBoxDGA.Checked or
     (CheckBoxCodeLowell.Checked and (CheckBoxAten.Checked or CheckboxApollo.Checked or
      CheckBoxAmor.Checked or CheckBoxCROISEUR.Checked or
      CheckBoxMPC1.Checked or CheckBoxMPC2.Checked or CheckBoxMPC3.Checked or
      CheckBoxMPC4.Checked or CheckBoxMPC5.Checked or CheckBoxMPC6.Checked or
      CheckBoxMPC7.Checked or CheckBoxLowell5.Checked or CheckBoxLowell6.Checked or
      CheckBoxLowell7.Checked or CheckBoxLowell8.Checked or CheckBoxLowell9.Checked or
      CheckBoxLowell10.Checked or CheckBoxSurveyPLS.Checked or CheckBoxSurveyT1.Checked or
      CheckBoxSurveyT2.Checked or CheckBoxSurveyT3.Checked or CheckBoxSurveyUCAS.Checked )) or
     (CheckBoxCodeMPC.Checked and(CheckBoxMPCATEN.Checked or CheckBoxMPCAPOLLO.Checked or
      CheckBoxMPCAMOR.Checked or CheckBoxMPCPlutino.Checked or CheckBoxMPCTroyen.Checked or
      CheckBoxMPCCentaure.Checked or CheckBoxMPCTNOR.Checked or CheckBoxMPCCubewano.Checked or
      CheckBoxMPCPHA.Checked or CheckBoxMPCNew.Checked or CheckBoxMPCCritique.Checked ));
end;

procedure TForm1.CheckBoxHClick(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxDiamClick(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxInclClick(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxExcClick(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxDGAClick(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.ButtonAppliquerFiltreClick(Sender: TObject);
var
   fli,li : longint;
   code : integer;
   ok,oks,okc : boolean;
   s : string;
   C1,C2,C3,C4,C5,C6 : integer;
   FH,LH,Fdiam,Ldiam,FIncl,LIncl,FExc,LExc,FDGA,LDGA : real;
begin
   ButtonAppliquerFiltre.Caption:=Table_Msg[114];
   ButtonAppliquerFiltre.Enabled:=false;

   val(FiltreH.Text,FH,code);
   val(FiltreDiam.Text,FDiam,code);
   val(FiltreIncl.text,FIncl,code);
   val(FiltreExc.Text,Fexc,code);
   val(FiltreDGA.Text,FDGA,code);

   fli:=0;
   if Lecture_Lowell then
   for li:=1 to taille_liste do
   begin
      ok:=true;
      if CheckBoxH.Checked then
      begin
         val(liste[li]^.H,LH,code);
         oks:=FH < LH;
         if RadioButtonHSup.Checked then ok:=oks else ok:= not(oks);
      end;
      if CheckBoxDiam.Checked then
      begin
         val(liste[li]^.Diam,LDiam,code);
         oks:=FDiam < LDiam;
         if RadioButtonDiamSup.Checked then ok:=ok and oks else ok:= ok and not(oks);
      end;
      if CheckBoxIncl.Checked then
      begin
         val(liste[li]^.Inclin,LIncl,code);
         oks:=FIncl < LIncl;
         if RadioButtonInclSup.Checked then ok:=ok and oks else ok:= ok and not(oks);
      end;
      if CheckBoxExc.Checked then
      begin
         val(liste[li]^.Excent,LExc,code);
         oks:=FExc < LExc;
         if RadioButtonExcSup.Checked then ok:=ok and oks else ok:= ok and not(oks);
      end;
      if CheckBoxDGA.Checked then
      begin
         val(liste[li]^.DGA,LDGA,code);
         oks:=FDGA < LDGA;
         if RadioButtonDGASup.Checked then ok:=ok and oks else ok:= ok and not(oks);
      end;
      if CheckBoxCodeLowell.Checked then
      begin
         okc:=false;
         Val(liste[li]^.Code1,C1,code);
         Val(liste[li]^.Code2,C2,code);
         Val(liste[li]^.Code3,C3,code);
         Val(liste[li]^.Code4,C4,code);
         Val(liste[li]^.Code5,C5,code);
         Val(liste[li]^.Code6,C6,code);

         if CheckBoxAten.Checked then
            okc:=okc or ((C1 and 1)<>0);
         if CheckBoxApollo.Checked then
            okc:=okc or ((C1 and 2)<>0);
         if CheckBoxAmor.Checked then
            okc:=okc or ((C1 and 4)<>0);
         if CheckBoxCROISEUR.Checked then
            okc:=okc or (C1>8);

         if CheckBoxMPC1.Checked then
            okc:=okc or (C4=1);
         if CheckBoxMPC2.Checked then
            okc:=okc or (C4=2);
         if CheckBoxMPC3.Checked then
            okc:=okc or (C4=3);
         if CheckBoxMPC4.Checked then
            okc:=okc or (C4=4);
         if CheckBoxMPC5.Checked then
            okc:=okc or (C4=5);
         if CheckBoxMPC6.Checked then
            okc:=okc or (C4=6);
         if CheckBoxMPC7.Checked then
            okc:=okc or (C4=7);
         if CheckBoxLowell5.Checked then
            okc:=okc or (C6=5);
         if CheckBoxLowell6.Checked then
            okc:=okc or (C6=6);
         if CheckBoxLowell7.Checked then
            okc:=okc or (C6=7);
         if CheckBoxLowell8.Checked then
            okc:=okc or (C6=8);
         if CheckBoxLowell9.Checked then
            okc:=okc or (C6=9);
         if CheckBoxLowell10.Checked then
            okc:=okc or (C6=10);
         if CheckBoxSurveyPLS.checked then
            okc:=okc or ((C3 and 1)<>0);
         if CheckBoxSurveyT1.checked then
            okc:=okc or ((C3 and 16)<>0);
         if CheckBoxSurveyT2.checked then
            okc:=okc or ((C3 and 2)<>0);
         if CheckBoxSurveyT3.checked then
            okc:=okc or ((C3 and 4)<>0);
         if CheckBoxSurveyUCAS.checked then
            okc:=okc or ((C3 and 8)<>0);
         ok:=ok and okc;
      end;
      if ok then
      begin
         inc(fli);
         liste_filtree[fli]:=li;
      end;
   end;

   if Lecture_MPC then
   for li:=1 to taille_liste do
   begin
      ok:=true;
      if CheckBoxH.Checked then
      begin
         val(liste[li]^.H,LH,code);
         oks:=FH < LH;
         if RadioButtonHSup.Checked then ok:=oks else ok:= not(oks);
      end;
      if CheckBoxDiam.Checked then
      begin
         val(liste[li]^.Diam,LDiam,code);
         oks:=FDiam < LDiam;
         if RadioButtonDiamSup.Checked then ok:=ok and oks else ok:= ok and not(oks);
      end;
      if CheckBoxIncl.Checked then
      begin
         val(liste[li]^.Inclin,LIncl,code);
         oks:=FIncl < LIncl;
         if RadioButtonInclSup.Checked then ok:=ok and oks else ok:= ok and not(oks);
      end;
      if CheckBoxExc.Checked then
      begin
         val(liste[li]^.Excent,LExc,code);
         oks:=FExc < LExc;
         if RadioButtonExcSup.Checked then ok:=ok and oks else ok:= ok and not(oks);
      end;
      if CheckBoxDGA.Checked then
      begin
         val(liste[li]^.DGA,LDGA,code);
         oks:=FDGA < LDGA;
         if RadioButtonDGASup.Checked then ok:=ok and oks else ok:= ok and not(oks);
      end;
      if CheckBoxCodeMPC.Checked then
      begin
         Val(liste[li]^.Code1,C1,code);
         Val(liste[li]^.Code2,C2,code);

         okc:=false;
         if CheckBoxMPCAten.Checked then
            okc:=okc or (C1=2);
         if CheckBoxMPCApollo.Checked then
            okc:=okc or (C1=3);
         if CheckBoxMPCAmor.Checked then
            okc:=okc or (C1=4);
         if CheckBoxMPCPlutino.Checked then
            okc:=okc or (C1=14);
         if CheckBoxMPCTroyen.Checked then
            okc:=okc or (C1=9);
         if CheckBoxMPCCentaure.Checked then
            okc:=okc or (C1=10);
         if CheckBoxMPCTNOR.Checked then
            okc:=okc or (C1=15);
         if CheckBoxMPCCubewano.Checked then
            okc:=okc or (C1=16);
         if CheckBoxMPCPHA.Checked then
            okc:=okc or ((C2 and 128)<>0);
         if CheckBoxMPCNew.Checked then
            okc:=okc or ((C2 and 32)<>0);
         if CheckBoxMPCCritique.Checked then
            okc:=okc or ((C2 and 64)<>0);
         ok:=ok and okc;
      end;
      if ok then
      begin
         inc(fli);
         liste_filtree[fli]:=li;
      end;
   end;

   str(fli,s);
   label10.Caption:=s+' '+Table_Msg[115];
   Taille_liste_filtree:=fli-1;  { TODO 2 -cCalcul : fli-1  modifer }
   SB_Max.Caption:=s;
   if fli>0 then
   begin
      Scrollbar1.Max:=Taille_liste_filtree;
      Update_StringGrid1;
   end;
   ButtonAppliquerFiltre.Caption:=Table_Msg[116];
   ButtonAppliquerFiltre.Enabled:=true;
end;

procedure TForm1.ButtonFileMPCSeekClick(Sender: TObject);
begin
   Opendialog1.InitialDir:=ExtractFileDir(fichier_MPC.Text);
   if Opendialog1.Execute then
      If FileExists(Opendialog1.FileName) then
      begin
         fichier_MPC.Text:=Opendialog1.FileName;
         ButtonCreeBaseMPC.Enabled:=true;
      end
      else
      begin
         fichier_MPC.Text:='';
         ButtonCreeBaseMPC.Enabled:=false;
      end;
end;

procedure TForm1.ButtonCreeBaseMPCClick(Sender: TObject);
var
   astorb     : textfile;
   buffer     : string;
   compteur   : longint;
   s,s1,s2,s3 : string;
   NDGA,NExc,Nq,Nopp : real;
   code,C1,C2,C3,C4  : integer;
   DEpoque           : T_Date;
   erreur            : boolean;
begin
   If FileExists(Fichier_MPC.text) then
   begin
      AssignFile(astorb,Fichier_MPC.text);
      Reset(astorb);

      LMessage.Top:=424;
      LMessage.Caption:=Table_Msg[160];

      { Passage de l'entete MPC }
      repeat
         readln(astorb,buffer);
      until (copy(buffer,1,5)='-----') or (eof(astorb));
      { L'entte est passe si elle existe }

      if eof(astorb) then reset(astorb); { Cas des fichiers sans enttes }
      compteur:=0;
      repeat
         readln(astorb,buffer);
         if buffer<>'' then   { il faut tenir compte de la ligne vide de sparation entre
                                les objets numrots et les suivants (vers 157000 en mai 2007 }
         begin
            inc(compteur);
            new(liste[compteur]);
            with liste[compteur]^ do
            begin
               {Str(compteur,numero);} numero:=copy(buffer,1,7);    {ok}
               str(compteur,s);
               nom:=(copy(buffer,176,18));                {ok}
               H:=Trim(copy(buffer,9,5));                           {ok}
               BMV:='';  { modifi plus bas }
               diam:=copy(buffer,15,5);  { en fait G }        { ok }
               IClass:=' '; {copy(buffer,65,4);}

               compact_to_date(copy(buffer,21,5), DEpoque, erreur);
               with DEpoque do
               begin
                  Str(Jour,s3); if Jour<10 then s3:='0'+s3;
                  Str(Mois,s2); if Mois<10 then s2:='0'+s2;
                  Str(Annee:4,s1);
               end;
               Epoque:=s3+'/'+s2+'/'+s1;
               AnomMoy:=copy(buffer,27,9);                    {ok}
               ArgPer:=copy(buffer,38,9);                     {ok}
               LongNod:=copy(buffer,49,9);                    {ok}
               Inclin:= copy(buffer,60,9);                    {ok}
               Excent:= copy(buffer,71,9);                    {ok}
               DGA:=copy(buffer,93,11);                       {ok}
               Val(DGA,NDGA,code);
               Val(Excent,NExc,code);
//               Val(Trim(copy(buffer,124,3)),NOpp,code);

//               if NExc<0 then Nq:=NDGA*(1-NExc) else Nq:=999.9;
               { Rgle de Classification des Objets }
//               if (NDGA<1.0) then C1:=1;
//               if (NDGA>1.0) and (Nq<1.0) then C1:=C1+2;
//               if (NDGA>1.0167) and (Nq>1.0167) then C1:=C1+4;  { TODO 1 -cCalcul : Complter la dfinition du type Amor (q< ?) }
//               if Nopp=2 then C4:=2;
//               if Nopp=3 then C4:=3;
               { TODO 1 -cCalcul : Complter la dfinition du Code 4 (Nb d'apparitions) }
               Code1:=Copy(buffer,165,1);
               Code2:=Copy(buffer,164,1);
               Code3:=Copy(buffer,163,1);
               Code4:=Copy(buffer,162,1);

               BMV:=Code4+Code3+Code2+Code1;

               C1:=char_alpha(Code1[1])+16*char_alpha(Code2[1]);
               Str(C1,Code1);
               C2:=char_alpha(Code3[1])+16*char_alpha(Code4[1]);
               Str(C2,Code2);
               Code3:='';
               Code4:='';
              { Str(C5,Code5); } Code5:='';
              { Str(C6,Code6); } Code6:='';

               with Table_Tri[2*compteur-1] do
               begin
                  rang:=compteur;
                  Value:=Numero; {Str(compteur,value);}
               end;
               with Table_Tri[2*compteur] do
               begin
                  rang:=compteur;
                  value:=Trim(nom);
               end;

            end;
            Liste_Filtree[compteur]:=compteur;
         end;
      until eof(astorb);
      closefile(astorb);
      s:='';

      taille_liste:=compteur;
      taille_liste_filtree:=compteur;

      StringGrid1.RowCount:=1001;
      str(compteur,s);
      l_compteur.Caption:=s+' '+Table_Msg[113];
      SB_Max.Caption:=s;
      Orbite.TabVisible:=true;
      With Scrollbar1 do
      begin
         Max:=compteur;
         SmallChange:=1000;
      end;
      debut_actuel:=1;

      LMessage.Caption:=Table_Msg[161];
      SortTable(Table_Tri,2*compteur);
      LMessage.Caption:=Table_Msg[162];

      StringGrid1.Cells[ 4,0]:='Code'; { au lieu de B-V }
      StringGrid1.Cells[ 5,0]:='G'; { au lieu de Diam }
      Update_StringGrid1;

      ButtonFileMPCSeek.Enabled:=false;
      ButtonCreeBaseMPC.Enabled:=false;
      ButtonFileLowellSeek.Enabled:=false;
      ButtonCreeBaseLowell.Enabled:=false; { Ainsi, si le fichier est lu, on ne peut plus
                                  recrer la liste }
      CheckBoxDiam.Enabled:=false;
      GroupBox2.Enabled:=False;
      Orbite.Enabled:=true;
      Filtrage.Enabled:=true;
      StringGrid1.Visible:=true;
      Lecture_Lowell:=false;
      Lecture_MPC:=true;
      DisableLowellCheck;
   end


end;

procedure TForm1.mise_a_jour_detail(objet_selectionne : longint);
var
   s : string;
   v,code : integer;
begin
   str(objet_selectionne,s);
   LabelSelection.Caption:=s;

   with  liste[objet_selectionne]^ do
   begin
       LabelVRang.Caption:=s;
       if Trim(numero)<>'' then
          LabelVNom.caption:='('+Trim(numero)+') '+nom
       else
          LabelVNom.caption:=nom;
       LabelVNumero.caption:=numero;
       LabelVH.caption:=H;
       LabelVBMV.caption:=BMV;
       LabelVDiam.caption:=Diam;
       LabelVClassIRAS.Caption:=IClass;
       LabelVEpoque.Caption:=Epoque;
       LabelVAnomMoy.Caption:=AnomMoy;
       LabelVArgPer.caption:=ArgPer;
       LabelVLongNod.Caption:=LongNod;
       LabelVInclin.Caption:=Inclin;
       LabelVExcent.Caption:=Excent;
       LabelVDGA.Caption:=DGA;

       val(code1,v,code);
       case v of
       0 : LabelVCode1.Caption:='';
       1 : LabelVCode1.Caption:=Table_Msg[117];
       2 : LabelVCode1.Caption:=Table_Msg[118];
       4 : LabelVCode1.Caption:=Table_Msg[119];
       8 : LabelVCode1.Caption:=Table_Msg[120];
       16: LabelVCode1.Caption:=Table_Msg[121];
       else LabelVCode1.Caption:=Table_Msg[122];
       end;

       val(code2,v,code);
       case v of
        1 : LabelVCode2.Caption:=Table_Msg[123];
        2 : LabelVCode2.Caption:=Table_Msg[124];
        4 : LabelVCode2.Caption:=Table_Msg[125];
        8 : LabelVCode2.Caption:=Table_Msg[126];
        16: LabelVCode2.Caption:=Table_Msg[127];
        32: LabelVCode2.Caption:=Table_Msg[128];
        64: LabelVCode2.Caption:=Table_Msg[129];
       128: LabelVCode2.Caption:=Table_Msg[130];
       else LabelVCode2.Caption:='';
       end;

       val(code3,v,code);
       case v of
       1 : LabelVCode3.Caption:=Table_Msg[131];
       2 : LabelVCode3.Caption:=Table_Msg[132];
       4 : LabelVCode3.Caption:=Table_Msg[133];
       8 : LabelVCode3.Caption:=Table_Msg[134];
       16: LabelVCode3.Caption:=Table_Msg[135];
       else LabelVCode3.Caption:=Table_Msg[136];
       end;

       val(code4,v,code);
       case v of
       1 : LabelVCode4.Caption:=Table_Msg[137];
       2 : LabelVCode4.Caption:=Table_Msg[138];
       3 : LabelVCode4.Caption:=Table_Msg[139];
       4 : LabelVCode4.Caption:=Table_Msg[140];
       5 : LabelVCode4.Caption:=Table_Msg[141];
       6 : LabelVCode4.Caption:=Table_Msg[142];
       7 : LabelVCode4.Caption:=Table_Msg[143];
       else LabelVCode4.Caption:='';
       end;

       val(code5,v,code);
       case v of
       1 : LabelVCode5.Caption:=Table_Msg[144];
       2 : LabelVCode5.Caption:=Table_Msg[145];
       3 : LabelVCode5.Caption:=Table_Msg[146];
       else LabelVCode5.Caption:='';
       end;

       val(code6,v,code);
       case v of
       10 : LabelVCode6.Caption:=Table_Msg[147];
        9 : LabelVCode6.Caption:=Table_Msg[148];
        8 : LabelVCode6.Caption:=Table_Msg[149];
        7 : LabelVCode6.Caption:=Table_Msg[150];
        6 : LabelVCode6.Caption:=Table_Msg[151];
        5 : LabelVCode6.Caption:=Table_Msg[152];
       else LabelVCode6.Caption:='';
       end;

{  {    ,Code6     }
   end;
end;


procedure TForm1.StringGrid1Click(Sender: TObject);
var
   myrect: TGridRect;
begin
   objet_selectionne:=Liste_filtree[debut_actuel+Stringgrid1.Row-1];
   with myRect do
   begin
      Left:=0; Right:=14;
      Top:=Stringgrid1.Row;
      Bottom:=Stringgrid1.Row;
   end;
   StringGrid1.Selection:=myrect;

{ Mise  jour de la page Dtails : }
   mise_a_jour_detail(objet_selectionne);
end;

procedure TForm1.ButtonFTPLowellClick(Sender: TObject);
begin
    DemandeChargement:=DemandeChargementLowell;
    Form2.Show;
end;

procedure TForm1.Recherche_asteroide(Cle : string;Taille : longint;
                              var resultat : longint;
                              var trouve   : boolean);
var
   premier,dernier,milieu : longint;
   arret                  : boolean;
   s                      : string;
begin
   milieu:=Taille div 2;
   premier:=1;
   dernier:=Taille;

   arret:=false;
   trouve:=false;
   resultat:=0;

   repeat
      Str(milieu,s);
      {LMessage2.Caption:='/'+cle+'/';}
      if Table_Tri^[milieu].value<cle then premier:=milieu else dernier:=milieu;
      milieu:=(premier+dernier) div 2;
      if Table_Tri^[milieu].value=cle then trouve:=true
         else if (dernier-premier)<=2 then arret:=true;


   until trouve or arret;

   if trouve then
   begin
      resultat:=Table_Tri^[milieu].rang;
      Str(resultat,s);
      (* LMessage2.Caption:='/'+cle+'/ Trouv au rang '+s; *)
   end else LMessage2.Caption:='['+cle+'] Non trouv.';

end;

procedure TForm1.Button2Click(Sender: TObject);
var
   key : string;
   Trouve : boolean;
   Index  : longint;
begin
   Key:=Edit1.Text;
   Trouve:=False;
   Recherche_Asteroide(Key,Taille_Liste*2,index,Trouve);
   If trouve then
   begin
      Objet_selectionne:=Index;
      mise_a_jour_detail(objet_selectionne);
      TabSheet2.PageIndex:=5;
   end;
end;

procedure TForm1.VoirElements1Click(Sender: TObject);
var
   myrect: TGridRect;
begin
   objet_selectionne:=Liste_filtree[debut_actuel+Stringgrid1.Row-1];
   with myRect do
   begin
      Left:=0; Right:=14;
      Top:=Stringgrid1.Row;
      Bottom:=Stringgrid1.Row;
   end;
   StringGrid1.Selection:=myrect;

{ Mise  jour de la page Dtails : }
   mise_a_jour_detail(objet_selectionne);
   TabSheet2.PageIndex:=5;
end;

procedure TForm1.StringGrid1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
   R,C : longint;
   myrect: TGridRect;
begin
   StringGrid1.MouseToCell(X,Y,C,R);
   objet_selectionne:=Liste_filtree[debut_actuel+R-1];
   with myRect do
   begin
      Left:=0; Right:=14;
      Top:=R;
      Bottom:=R;
   end;
   StringGrid1.Selection:=myrect;

{ Mise  jour de la page Dtails : }
   mise_a_jour_detail(objet_selectionne);

end;

procedure TForm1.Ajout_objet(objet : longint);
var
   s : string;
   i : longint;
   in_liste : boolean;
begin
   {Rechercher si l'objet n'est pas dj dans la liste}
   in_liste:=false;
   Str(objet,s);

   for i:=1 to objet_selectionne_liste do
      if StringGrid2.Cells[0,i]=s then in_liste:=true;
   if not in_liste then
   begin
      StringGrid2.RowCount:=StringGrid2.RowCount+1;
      StringGrid2.FixedRows:=1;
      StringGrid2.Cells[0,objet_selectionne_liste+1]:=s;
      StringGrid2.Cells[1,objet_selectionne_liste+1]:=liste[objet]^.numero;
      StringGrid2.Cells[2,objet_selectionne_liste+1]:=liste[objet]^.nom;
      inc(objet_selectionne_liste);
      BitBtnEffaceListe.Enabled:=True;
      BitBtnSauveListe.Enabled:=True;
   end;
end;

procedure TForm1.PopupTableClick(Sender: TObject);
begin
    { Ajouter l'lment slectionn par le menu popup1  la liste des astroides
      stocke dans StringGrid2}
    if objet_selectionne<>0 then
    begin
        Ajout_objet(objet_selectionne);
    end;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
    { Ajouter l'objet 'objet_selectionne' dans StringGrid2 }
    if objet_selectionne<>0 then
    begin
        Ajout_objet(objet_selectionne);
    end;
end;

procedure TForm1.BitBtnEffaceListeClick(Sender: TObject);
begin
   objet_selectionne_liste:=0;
   StringGrid2.RowCount:=1;
   StringGrid2.FixedRows:=0;
   BitBtnEffaceListe.Enabled:=False;
   BitBtnSauveListe.Enabled:=False;
end;

procedure TForm1.BitBtnSauveListeClick(Sender: TObject);
var
   f        : textfile;
   scratch  : boolean;
   i,k,code : longint;
begin
   if objet_selectionne_liste>0 then
   begin
      Scratch:=true;
      If SaveDialog1.Execute then
      begin
         IF fileExists(savedialog1.FileName) then
            if MessageDlg(Table_Msg[153],
                           mtConfirmation,[mbYes,mbNo],0,mbYes)<>mrYes then
               Scratch:=false;
         if scratch then
         begin
            Assignfile(f,SaveDialog1.FileName);
            Rewrite(f);
            for i:=1 to objet_selectionne_liste do
            begin
                Val(StringGrid2.Cells[0,i],k,code);
                with liste[k]^ do
                   Writeln(f,nom,',',k,',',numero);
            end;
            closefile(f);
         end
      end;
   end
end;

procedure TForm1.StringGrid2MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
   R,C : longint;
   myrect: TGridRect;
begin
   StringGrid2.MouseToCell(X,Y,C,R);
   selection_objet_selectionne_liste:=R-1;
   with myRect do
   begin
      Left:=0; Right:=14;
      Top:=R;
      Bottom:=R;
   end;
   StringGrid2.Selection:=myrect;
end;

procedure TForm1.Up1Click(Sender: TObject);
var
   pos : longint;
   myrect: TGridRect;
   S1,S2,S3 : string;
begin
   myrect:=StringGrid2.Selection;
   pos:=myrect.Top;
   if pos>1 then
   begin
      S1:=StringGrid2.Cells[0,pos-1];
      S2:=StringGrid2.Cells[1,pos-1];
      S3:=StringGrid2.Cells[2,pos-1];
      StringGrid2.Cells[0,pos-1]:=StringGrid2.Cells[0,pos];
      StringGrid2.Cells[1,pos-1]:=StringGrid2.Cells[1,pos];
      StringGrid2.Cells[2,pos-1]:=StringGrid2.Cells[2,pos];
      StringGrid2.Cells[0,pos]:=S1;
      StringGrid2.Cells[1,pos]:=S2;
      StringGrid2.Cells[2,pos]:=S3;
      with myRect do
      begin
         Left:=0; Right:=2;
         Top:=pos-1;
         Bottom:=pos-1;
      end;
      StringGrid2.Selection:=myrect;
   end;
end;

procedure TForm1.Descendre1Click(Sender: TObject);
var
   pos : longint;
   myrect: TGridRect;
   S1,S2,S3 : string;
begin
   myrect:=StringGrid2.Selection;
   pos:=myrect.Top;
   if pos<objet_selectionne_liste then
   begin
      S1:=StringGrid2.Cells[0,pos+1];
      S2:=StringGrid2.Cells[1,pos+1];
      S3:=StringGrid2.Cells[2,pos+1];
      StringGrid2.Cells[0,pos+1]:=StringGrid2.Cells[0,pos];
      StringGrid2.Cells[1,pos+1]:=StringGrid2.Cells[1,pos];
      StringGrid2.Cells[2,pos+1]:=StringGrid2.Cells[2,pos];
      StringGrid2.Cells[0,pos]:=S1;
      StringGrid2.Cells[1,pos]:=S2;
      StringGrid2.Cells[2,pos]:=S3;
      with myRect do
      begin
         Left:=0; Right:=2;
         Top:=pos+1;
         Bottom:=pos+1;
      end;
      StringGrid2.Selection:=myrect;
   end;
end;

procedure TForm1.Effacer1Click(Sender: TObject);
var
   i,pos : longint;
   myrect: TGridRect;
   S1,S2,S3 : string;
begin
   myrect:=StringGrid2.Selection;
   pos:=myrect.Top;
   if pos>=1 then
   begin
      if pos=objet_selectionne_liste then
      begin
         StringGrid2.Cells[0,pos]:='';
         StringGrid2.Cells[1,pos]:='';
         StringGrid2.Cells[2,pos]:='';
      end
      else
      for i:=pos to objet_selectionne_liste-1 do
      begin
         S1:=StringGrid2.Cells[0,i+1];
         S2:=StringGrid2.Cells[1,i+1];
         S3:=StringGrid2.Cells[2,i+1];
         StringGrid2.Cells[0,i]:=S1;
         StringGrid2.Cells[1,i]:=S2;
         StringGrid2.Cells[2,i]:=S3;
      end;
      StringGrid2.Rowcount:=StringGrid2.Rowcount-1;
   end
end;

procedure TForm1.VoirElements2Click(Sender: TObject);
var
   myrect: TGridRect;
   objet,code : longint;
begin
   with myRect do
   begin
      Left:=0; Right:=2;
      Top:=Stringgrid2.Row;
      Bottom:=Stringgrid2.Row;
      Val(StringGrid2.Cells[0,Top],objet,code);
   end;
   StringGrid2.Selection:=myrect;

{ Mise  jour de la page Dtails : }
   mise_a_jour_detail(objet);
{   TabSheet2.PageIndex:=5;}
   PageControl1.ActivePage:=TabSheet2;
end;

procedure TForm1.StringGrid2Click(Sender: TObject);
var
   myrect: TGridRect;
begin
   with myRect do
   begin
      Left:=0; Right:=3;
      Top:=Stringgrid2.Row;
      Bottom:=Stringgrid2.Row;
   end;
   StringGrid2.Selection:=myrect;
end;

procedure TForm1.BUpClick(Sender: TObject);
begin
   Up1Click(Sender)
end;

procedure TForm1.BDownClick(Sender: TObject);
begin
   Descendre1Click(Sender);
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
   Effacer1Click(Sender);
end;

procedure TForm1.BitBtn5Click(Sender: TObject);
begin
   VoirElements2Click(Sender);
end;

procedure TForm1.AujourdhuiClick(Sender: TObject);
var
   Present:TDateTime;
   annee,mois,jour : Word;
   s    : string;
begin
    Present:=Now;
    DecodeDate(Present,annee,mois,jour);
    Str(jour,S);    CB_jour.Text:=s;
    SE_annee.Value:=annee;
    CB_mois.ItemIndex:=mois-1;
end;

procedure TForm1.BMaintenantClick(Sender: TObject);
var
   Present                   :TDateTime;
   annee,mois,jour,heure,
   minute,seconde,msec       : Word;
   HD                        : real;
begin
    Present:=Now;
    DecodeTime(Present,heure,minute,seconde,msec);
    SE_heure.Value :=heure;
    SE_minute.Value:=minute;
    HD:=Heure+minute/60;
    begin
       DecodeDate(Present,annee,mois,jour);
       Ephem_date.heure:=HD;
       CB_jour.itemindex:=jour-1;
       CB_mois.ItemIndex:=mois-1;
       SE_annee.Value   :=annee;
    end;
end;

procedure TForm1.MinuitClick(Sender: TObject);
begin
    Ephem_Date.heure:=0;
    SE_heure.Value:=0;
    SE_minute.Value:=0;
end;
procedure TForm1.BEnckeClick(Sender: TObject);
var
   i,j,code,pas,
   nb_calcul     : integer;
   JJEphemDate,TSL,TSLL,TSLC,TSLM,AngleHoraireP : double;
   alphaP,deltaP,unite_pas     : real;
   Orbite_epoque : T_Date;
   orbite        : T_Orbite;
   positions     : T_position;
   NumeroOrbite  : longint;
   db            : boolean;
   s,sd          : string;
   t             : TextFile;

begin
   {D'abord rcuprer les lments orbitaux de l'astroide :}

   Memo2.Clear;
   db:=CheckBox2.Checked;
   nb_calcul:=SpinEdit2.Value;
   pas:=SpinEdit3.Value;
   case combobox4.ItemIndex of
   0 : unite_pas:=1.0;
   1 : unite_pas:=1.0/24;
   else unite_pas:=1.0;
   end;
   if not db then Memo2.Append('JJ              TSL        Nom              Asc.Dr.Goc. Dclin.Go. Dist.Goc. Asc.Dr.Topo. Dclin.Topo.');
   for i:=1 to nb_calcul do
   begin
      Val(StringGrid2.Cells[0,i],NumeroOrbite,Code);
      With Liste[NumeroOrbite]^ do
      begin
         Nom:='ENCKE';
         if db then Memo2.Append('Calcul d''Ephemerides de '+Nom);
         if db then Memo2.Append('(VERIFICATION)');

         Val('28',Orbite_epoque.Jour,code);
         Val('10',Orbite_epoque.Mois,code);
         Val('1990',Orbite_epoque.Annee,code);
         Orbite.JJEpoque:=JJ(Orbite_epoque)+0.54502;
         with Orbite do
         begin
            Val('2.2091404',DemiAxe,code);
            Val('0.0000000',AnomMoy,code);  AnomMoy:=AnomMoy/180*Pi;
            Val('186.23352',ArgPer ,Code);  ArgPer:=ArgPer/180*Pi;
            Val('334.75006',LongNod,Code);  LongNod:=LongNod/180*Pi;
            Val('11.94524' ,Inclin ,code);  Inclin:=inclin/180*Pi;
            Val('0.8502196',Excent ,code);
         end;
      end;

      with ephem_date do
      begin
         Val('6',jour,code);
         annee:=1990;
         Mois:=10;
         heure:=0.0*24;
         JJEphemDate:=JJ(Ephem_date)+heure/24;
         str(Orbite.JJEpoque:12:3,s);
         if db then Memo2.Append('Jour Julien Epoque de l''orbite  : '+s);
      end;

      for j:=1 to 1 do
      begin
         str(JJEphemDate:12:3,s);
         if db then Memo2.Append('Jour Julien Instant de calcul   : '+s);

         calcul_ephemerides(JJEphemDate,db,orbite,positions);

         {Rcupration des messages gnrs lors du calcul de la position  : }

         AssignFile(t,'ephem.log');
         Reset(t);
         repeat
            readln(t,s);
            if s<>'' then Memo2.Append(s);
         until eof(t);
         closeFile(t);

         with Positions do
         begin
            Str(Dist_T:10:8,s);
            Str(JJEphemDate:13:5,sd);

            TSL:=Temps_Sideral_Local(JJEphemDate,Observatoire.Longitude*180/pi);
            Topocentrique(positions,observatoire,TSL,AlphaP,DeltaP);

            AngleHoraireP:=TSL-AlphaP;
            if angleHoraireP<0 then angleHoraireP:=AngleHoraireP+2*pi;
            Lever(AlphaP,DeltaP,observatoire,TSLL,TSLC,TSLM);

            if db then
            begin
               Memo2.Append('Position de '+Liste[NumeroOrbite]^.nom);
               Memo2.Append('Ascension Droite               : '+StringHMS(Alpha*12/pi,'hms'));
               Memo2.Append('Dclinaison                    : '+StringHMS(Delta*180/pi,'''"'));
               Memo2.Append('Distance  la Terre            :   '+s+' UA');
               Memo2.Append('Temps sideral local            : '+StringHMS(TSL,'hms'));
               Memo2.Append('Angle Horaire topocentrique    : '+StringHMS(AngleHoraireP/Pi*12,'hms'));
               Memo2.Append('Ascension droite topocentrique : '+stringHMS(AlphaP/pi*12,'hms'));
               Memo2.Append('Dclinaison topocentrique      : '+stringHMS(DeltaP/pi*180,'ms'));
               Memo2.Append('');
            end
            else
               Memo2.Append(sd+' '+StringHMS(TSL,'hms')+' '+Copy(Liste[NumeroOrbite]^.nom,1,15)+' '+StringHMS(Alpha*12/pi,'hms')
                            +' '+StringHMS(Delta*180/pi,'''"')+' '+s+' '+StringHMS(AlphaP*12/pi,'hms')+' '+StringHMS(Delta*180/pi,'''"'));

         end;
         JJEphemDate:=JJEphemDate+pas*unite_pas;
      end;
   end;

end;

procedure TForm1.CalculEphemClick(Sender: TObject);
var
   i,j,code,pas,
   nb_calcul     : integer;
   alphaP,deltaP : real;
   JJEphemDate,TSL,TSL0Greenwich,TSLL,TSLC,TSLM,AngleHoraireP,
   unite_pas     : double;
   Orbite_epoque : T_Date;
   orbite        : T_Orbite;
   positions     : T_position;
   NumeroOrbite  : longint;
   db            : boolean;
   s,sd,sm,buf       : string;
   t             : TextFile;

begin
   {D'abord rcuprer les lments orbitaux de l'astroide :}

   Memo2.Clear;
   db:=CheckBox2.Checked;
   nb_calcul:=SpinEdit2.Value;
   pas:=SpinEdit3.Value;
   case combobox4.ItemIndex of
   0 : unite_pas:=1.0;
   1 : unite_pas:=1.0/24;
   2 : unite_pas:=1.0/24/60;
   else unite_pas:=1.0;
   end;
   if not db then Memo2.Append('JJ              TSL        Nom              Asc.Dr.Goc. Dclin.Go. Dist.Goc.  Asc.Dr.Topo. Dclin.Topo.  Mag.');
   for i:=1 to objet_selectionne_liste do
   begin
      Val(StringGrid2.Cells[0,i],NumeroOrbite,Code);
      With Liste[NumeroOrbite]^ do
      begin
         if db then Memo2.Append('Calcul d''Ephemerides de '+Nom);
         if db then Memo2.Append(' ');

         Val(Copy(Epoque,1,2),Orbite_epoque.Jour,code);
         Val(Copy(Epoque,4,2),Orbite_epoque.Mois,code);
         Val(Copy(Epoque,7,4),Orbite_epoque.Annee,code);
         Orbite.JJEpoque:=JJ(Orbite_epoque);
         Val(DGA,Orbite.DemiAxe,code);
         Val(AnomMoy,Orbite.AnomMoy,code);
         Val(ArgPer ,Orbite.ArgPer ,Code);
         Val(LongNod,Orbite.LongNod,Code);
         Val(Inclin ,Orbite.Inclin ,code);
         Val(Excent ,Orbite.Excent ,code);
         Val(H,Orbite.H,code);
         Val(G,Orbite.G,code);
         With orbite do
         begin
            AnomMoy:=AnomMoy/180*Pi;
            ArgPer:=ArgPer/180*Pi;
            LongNod:=LongNod/180*Pi;
            Inclin:=inclin/180*Pi;
         end;
      end;

      with ephem_date do
      begin
         Val(CB_jour.Text,jour,code);
         annee:=SE_annee.value;
         Mois:=CB_mois.ItemIndex+1;
         heure:=SE_heure.Value+SE_minute.Value/60;
         JJEphemDate:=JJ(Ephem_date)+heure/24;
         str(Orbite.JJEpoque:12:3,s);
         if db then Memo2.Append('Jour Julien Epoque de l''orbite  : '+s);
      end;

      for j:=1 to nb_calcul do
      begin
         str(JJEphemDate:12:3,s);
         if db then Memo2.Append('Jour Julien Instant de calcul   : '+s);

         calcul_ephemerides(JJEphemDate,db,orbite,positions);

         {Rcupration des messages gnrs lors du calcul de la position  : }

         AssignFile(t,'ephem.log');
         Reset(t);
         repeat
            readln(t,s);
            if s<>'' then Memo2.Append(s);
         until eof(t);
         BSaveLog.Enabled:=True;
         closeFile(t);

         with Positions do
         begin
            Str(Dist_T:11:8,s);
            Str(JJEphemDate:13:5,sd);
            TSL0Greenwich:=Temps_Sideral_Greenwich_0h(JJEphemDate);
            {TSL0Greenwich:=Modulo(TSL0Greenwich,2*Pi);}
            TSL:=Temps_Sideral_Local(JJEphemDate,Observatoire.Longitude*180/pi);
            {TSL:=Modulo(TSL,2*Pi);}
            Topocentrique(positions,observatoire,TSL,AlphaP,DeltaP);

            AngleHoraireP:=TSL-AlphaP;
            if angleHoraireP<0 then angleHoraireP:=AngleHoraireP+2*pi;
            Lever(AlphaP,DeltaP,observatoire,TSLL,TSLC,TSLM);
            if Magnitude<30 then Str(Magnitude:5:2,sm) else sm:='--.--';

            if db then
            begin
               Memo2.Append('Position de '+Liste[NumeroOrbite]^.nom);
               Memo2.Append('Ascension Droite               : '+StringHMS(Alpha*12/pi,'hms'));
               Memo2.Append('Dclinaison                    : '+StringHMS(Delta*180/pi,'''"'));
               Memo2.Append('Distance  la Terre            :   '+s+' UA');
               Memo2.Append('');
               Memo2.Append('Longitude                      : ');
               Memo2.Append('Temps sideral Greenwich 0h     : '+StringHMS(TSL0Greenwich*12/Pi,'hms'));
               Memo2.Append('Temps sideral local            : '+StringHMS(TSL*12/Pi,'hms'));
               Memo2.Append('Angle Horaire topocentrique    : '+StringHMS(AngleHoraireP/Pi*12,'hms'));
               Memo2.Append('Ascension droite topocentrique : '+stringHMS(AlphaP/pi*12,'hms'));
               Memo2.Append('Dclinaison topocentrique      : '+stringHMS(DeltaP/pi*180,'ms'));
               Memo2.Append('Magnitude                      : '+sm);
            end
            else
            begin
               buf:=sd+' '+StringHMS(TSL,'hms')+' '+Copy(Liste[NumeroOrbite]^.nom,1,15)+' '+StringHMS(Alpha*12/pi,'hms')
                            +' '+StringHMS(Delta*180/pi,'''"')+' '+s+' '+StringHMS(AlphaP*12/pi,'hms')+' '+StringHMS(Delta*180/pi,'''"')+' '+sm;
               Memo2.Append(buf);
            end;

         end;
         JJEphemDate:=JJEphemDate+pas*unite_pas;
      end;
   end;
end;

procedure TForm1.Image2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
   u : real;
begin
    With observatoire do
    begin
       Longitude:=(X-450)/450*180;
       if Longitude<0 then Longitude:=Longitude+360;
       Latitude:=(253-Y)/252*90;
       Longitude:=Longitude/180*pi;
       Latitude:=Latitude/180*pi;
       altitude:=SpinAltitude.Value;
       u:=Arctan(BSA*tan(Latitude));
       RhoCosphiP:=cos(u)+altitude/Rayon_Terre_Eq*cos(Latitude);  { A modifier en fonction de l'altitude du lieu }
       RhoSinPhiP:=BSA*sin(u)+Altitude/Rayon_Terre_Eq*sin(Latitude);
    end;
   PageControl1Enter(Sender);
end;

procedure TForm1.PageControl1Enter(Sender: TObject);
var
   s : string;
begin
   with observatoire do
   begin
      str(Longitude*180/pi:8:4,s);
      LLongitude.Caption:=s;
      str(Latitude*180/pi:8:4,s);
      LLatitude.Caption:=s;
      str(Altitude:9:6,s);
      SpinAltitude.Value:=Trunc(Altitude);
   end;
end;

procedure TForm1.TabSheet5Enter(Sender: TObject);
begin
   SE_Annee.Enabled:=false;
   SE_Heure.Enabled:=false;
   SE_Minute.Enabled:=false;
   CB_jour.Enabled:=false;
   CB_mois.Enabled:=false;
   with ephem_date do
   begin
      SE_heure.Value   :=Trunc(heure);
      SE_minute.Value  :=Trunc(60*(Heure-Trunc(heure)));
      SE_annee.Value   :=annee;
      CB_mois.ItemIndex:=mois-1;
{      CB_Mois.Text:=CB_Mois.Items[mois-1] ;}
      CB_jour.Itemindex:=jour-1;
   end;
   SE_Annee.Enabled:=true;
   SE_Heure.Enabled:=true;
   SE_Minute.Enabled:=true;
   CB_jour.Enabled:=true;
   CB_mois.Enabled:=true;
end;

procedure TForm1.CB_JourChange(Sender: TObject);
begin
   with ephem_date do
   begin
      jour:=CB_jour.ItemIndex+1;
      Mois:=CB_mois.ItemIndex+1;
      annee:=SE_annee.value;
      heure:=SE_heure.Value+SE_minute.Value/60;
   end;
end;

procedure TForm1.CB_MoisChange(Sender: TObject);
begin
   CB_jourChange(Sender);
end;

procedure TForm1.SE_AnneeChanged(Sender: TObject; NewValue: Integer);
begin
   CB_jourChange(Sender);
end;

procedure TForm1.SE_HeureChanged(Sender: TObject; NewValue: Integer);
begin
   CB_jourChange(Sender);
end;

procedure TForm1.SE_minuteChanged(Sender: TObject; NewValue: Integer);
begin
   CB_jourChange(Sender);
end;

procedure TForm1.CB_ObservatoireChange(Sender: TObject);
var
   k : integer;
begin
   k:=CB_Observatoire.ItemIndex+1;
   With observatoire do
   begin
      Longitude:=Liste_Observatoire[k].Longitude;
      Latitude:=Liste_Observatoire[k].Latitude;
      Altitude:=Liste_Observatoire[k].Altitude;
      Nom:=Liste_Observatoire[k].nom;
      Code:=Liste_Observatoire[k].code;
      RhoCosphiP:=Liste_Observatoire[k].RhoCosphiP;
      RhoSinPhiP:=Liste_Observatoire[k].RhoSinPhiP;
   end;
   PageControl1Enter(Sender);
end;

procedure TForm1.BGeocentriqueClick(Sender: TObject);
begin
   With Observatoire do
   begin
      Longitude:=0;
      Latitude:=0;
      Altitude:=0;
      Code:='500';
      Nom:='Gocentrique';
      RhoCosphiP:=0;
      RhoSinPhiP:=0;
   end;
   PageControl1Enter(Sender);
end;

procedure TForm1.CB_UAIChange(Sender: TObject);
var
   k : integer;
begin
   k:=CB_UAI.ItemIndex+1;
   With observatoire do
   begin
      Longitude:=Liste_Observatoire[k].Longitude;
      Latitude:=Liste_Observatoire[k].Latitude;
      Altitude:=Liste_Observatoire[k].Altitude;
      Nom:=Liste_Observatoire[k].nom;
      Code:=Liste_Observatoire[k].code;
      RhoCosphiP:=Liste_Observatoire[k].RhoCosphiP;
      RhoSinPhiP:=Liste_Observatoire[k].RhoSinPhiP;
   end;
   LabelUAI.Caption:=Copy(observatoire.Nom,1,40);
   PageControl1Enter(Sender);
end;

procedure TForm1.fichier_lowellChange(Sender: TObject);
begin
  If FileExists(fichier_lowell.Text) then
     ButtonCreeBaseLowell.Enabled:=true
  else
     ButtonCreeBaseLowell.Enabled:=false
end;

procedure TForm1.ButtonCalculerToutOptClick(Sender: TObject);
var
   i,j,code,pas,
   nb_calcul     : integer;
   alphaP,deltaP : real;
   JJEphemDate,TSL,TSL0Greenwich,TSLL,TSLC,TSLM,AngleHoraireP,
   unite_pas     : double;
   Orbite_epoque : T_Date;
   orbite        : T_Orbite;
   positions     : T_position;
   NumeroOrbite  : longint;
   db            : boolean;
   s,sd,sm,buf       : string;
   t             : TextFile;
begin
   {D'abord rcuprer les lments orbitaux de l'astroide :}

   Memo2.Clear;
   db:=false; {CheckBox2.Checked;}
   nb_calcul:=SpinEdit2.Value;
   pas:=SpinEdit3.Value;
   case combobox4.ItemIndex of
   0 : unite_pas:=1.0;
   1 : unite_pas:=1.0/24;
   2 : unite_pas:=1.0/24/60;
   else unite_pas:=1.0;
   end;
   if not db then Memo2.Append('JJ              TSL        Nom              Asc.Dr.Goc. Dclin.Go. Dist.Goc.  Asc.Dr.Topo. Dclin.Topo.  Mag.');

   with ephem_date do
   begin
      Val(CB_jour.Text,jour,code);
      annee:=SE_annee.value;
      Mois:=CB_mois.ItemIndex+1;
      heure:=SE_heure.Value+SE_minute.Value/60;
      JJEphemDate:=JJ(Ephem_date)+heure/24;
      str(Orbite.JJEpoque:12:3,s);
      if db then Memo2.Append('Jour Julien Epoque de l''orbite  : '+s);
   end;

   for j:=1 to nb_calcul do
   begin
      str(JJEphemDate:12:3,s);
      if db then Memo2.Append('Jour Julien Instant de calcul   : '+s);

      for i:=1 to taille_liste_filtree+1 do { +1 car la variable taille_liste_filtree est dcrmente lors du filtrage }
      begin
         NumeroOrbite:=Liste_filtree[i];

         With Liste[NumeroOrbite]^ do
         begin
            if db then Memo2.Append('Calcul d''Ephemerides de '+Nom);
            if db then Memo2.Append(' ');

            Val(Copy(Epoque,1,2),Orbite_epoque.Jour,code);
            Val(Copy(Epoque,4,2),Orbite_epoque.Mois,code);
            Val(Copy(Epoque,7,4),Orbite_epoque.Annee,code);
            Orbite.JJEpoque:=JJ(Orbite_epoque);
            Val(DGA,Orbite.DemiAxe,code);
            Val(AnomMoy,Orbite.AnomMoy,code);
            Val(ArgPer ,Orbite.ArgPer ,Code);
            Val(LongNod,Orbite.LongNod,Code);
            Val(Inclin ,Orbite.Inclin ,code);
            Val(Excent ,Orbite.Excent ,code);
            Val(H,Orbite.H,code);
            Val(G,Orbite.G,code);
            With orbite do
            begin
               AnomMoy:=AnomMoy/180*Pi;
               ArgPer:=ArgPer/180*Pi;
               LongNod:=LongNod/180*Pi;
               Inclin:=inclin/180*Pi;
            end;
         end;

         calcul_ephemerides(JJEphemDate,db,orbite,positions);

         {Rcupration des messages gnrs lors du calcul de la position  : }

         AssignFile(t,'ephem.log');
         Reset(t);
         repeat
            readln(t,s);
            if s<>'' then Memo2.Append(s);
         until eof(t);
         BSaveLog.Enabled:=True;
         closeFile(t);

         with Positions do
         begin
            Str(Dist_T:11:8,s);
            Str(JJEphemDate:13:5,sd);
            TSL0Greenwich:=Temps_Sideral_Greenwich_0h(JJEphemDate);
            {TSL0Greenwich:=Modulo(TSL0Greenwich,2*Pi);}
            TSL:=Temps_Sideral_Local(JJEphemDate,Observatoire.Longitude*180/pi);
            {TSL:=Modulo(TSL,2*Pi);}
            Topocentrique(positions,observatoire,TSL,AlphaP,DeltaP);

            AngleHoraireP:=TSL-AlphaP;
            if angleHoraireP<0 then angleHoraireP:=AngleHoraireP+2*pi;
            Lever(AlphaP,DeltaP,observatoire,TSLL,TSLC,TSLM);
            if Magnitude<30 then Str(Magnitude:5:2,sm) else sm:='--.--';


            buf:=sd+' '+StringHMS(TSL,'hms')+' '+Copy(Liste[NumeroOrbite]^.nom,1,15)+' '
                 +StringHMS(Alpha*12/pi,'hms')
                 +' '+StringHMS(Delta*180/pi,'''"')+' '+s+' '+StringHMS(AlphaP*12/pi,'hms')
                 +' '+StringHMS(Delta*180/pi,'''"')+' '+sm;
            Memo2.Append(buf);
         end;
      end;
      JJEphemDate:=JJEphemDate+pas*unite_pas;
   end;
{   OpenDialog1.Title:=Table_Msg[53];
   if Opendialog1.Execute then
      If FileExists(Opendialog1.FileName) then
      begin
         assignfile(t,'.tdcrc');
         rewrite(t);
         writeln(t,Opendialog1.FileName);
         closefile(t);
         ShowMessage(Table_Msg[52]);
      end     }
   
end;

procedure TForm1.CBLangueChange(Sender: TObject);
var
   t : textfile;
   k : integer;
begin
   { interception de l'appel depuis FormCreate : }
   if not _FormCreate then
   begin
      assignfile(t,'.tdcrc');
      rewrite(t);
      writeln(t,'//Langue actuelle :');
      writeln(t,CBLangue.Items[CBLangue.ItemIndex]);
      writeln(t,'//Langue possible :');
      for k:=0 to Nbre_langue-1 do
         writeln(t,NLangue[k]);
      closefile(t);
      ShowMessage(Table_Msg[52]);

   end;
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
var
   f        : TextFile;
   key      : string;
   index    : longint;
   l_objet  : T_orbiteAscii;
   Trouve   : boolean;
begin
    OpenDialog1.Execute;
    if FileExists(opendialog1.FileName) then
    begin
       Assignfile(f,OpenDialog1.FileName);
       Reset(f);
       objet_selectionne_liste:=0;
       StringGrid2.RowCount:=1;
       StringGrid2.FixedRows:=0;
       BitBtnEffaceListe.Enabled:=False;
       BitBtnSauveListe.Enabled:=False;
       repeat
          l_objet.nom:='';
          readln(f,l_objet.nom);
          Key:=Trim(l_objet.nom);
          Label65.Caption:='/'+key+'/';
          Recherche_Asteroide(Key,Taille_Liste*2,index,Trouve);
          If trouve then
          begin
             Objet_selectionne:=Index;
             Ajout_objet(Index);
          end;
        until eof(f);
       closefile(f);
    end;
end;


procedure TForm1.BSaveLogClick(Sender: TObject);
var
   save_ok : boolean;
   F_out   : textFile;
   i       : longint;
begin
   If SaveDialog1.Execute then
   begin
     { save_ok:=false; }
      If FileExists(SaveDialog1.FileName) then
         if MessageDlg(Table_Msg[154],mtConfirmation,[mbYes, mbNo], 0, mbYes) = mrYes then
            save_Ok:=true else save_ok:=false
      else
         save_ok:=true;
      if save_ok then
      begin
         AssignFile(F_out,SaveDialog1.FileName);

         Rewrite(F_out);
         for i:=0 to Memo2.Lines.Count-1 do
            Writeln(F_out,Memo2.Lines.Strings[i]);
         CloseFile(F_out);
         BSaveLog.Enabled:=False;
      end;
   end;
end;

procedure TForm1.BRapportMPCClick(Sender: TObject);
begin
   Opendialog1.InitialDir:=ExtractFileDir(NomFichierRapportMPC.Text);
   OpenDialog1.Filter:=Table_Msg[155]+' (*.txt;*.dat;*.*)|*.txt;*.dat;*.*';
   if Opendialog1.Execute then
      If FileExists(Opendialog1.FileName) then
      begin
         NomFichierRapportMPC.Text:=Opendialog1.FileName;
         BAnalyseMesures.Enabled:=true;
      end
      else
      begin
         NomFichierRapportMPC.Text:='';
         BAnalyseMesures.Enabled:=false;
      end;

end;

procedure recherche_dichotomique_observatoire(nom : string; var index : integer);
var
   max,min,i,k : integer; {nbre_observatoire}
begin

   max:=nbre_observatoire;
   min:=1;
   k:=0;

   repeat
      inc(k);
      i:=(min+max) div 2;
      if liste_observatoire[i].code<nom then
      begin
         min:=i;
      end;

      if liste_observatoire[i].code>nom then
      begin
         max:=i;
      end;
   until (liste_observatoire[i].code=nom) or (k>100);

   if k<100 then index:=i else index:=-1;
   
end;

procedure TForm1.BAnalyseMesuresClick(Sender: TObject);
var
   f : textfile;
   buf,sub : string;
   index_obs,deca,k : integer;
   numero_obj : longint;
   mesure    : T_mesure;
   c         : char;
begin
{ il faut pouvoir lire le code de l'observatoire et les positions astromtriques }
{ Conventions adoptes : 1 seul code d'observatoire par fichier de mesures
                         plusieurs commandes NET peuvent tre indiques
                         les donnes des mesures doivent suivre les commandes NET }
   Assignfile(f,opendialog1.FileName);
   reset(f);
   Memo3.Lines.Clear;
   repeat
      readln(f,buf);
      if copy(buf,1,3)='COD' then
      begin  { recherche de l'observatoire cod sur les caractres 5  7}
         sub:=copy(buf,5,3);
         recherche_dichotomique_observatoire(sub,index_obs);
         if index_obs<0 then
            Memo3.Lines.Append('Observatoire non trouv dans la liste enregistre.')
         else
            Memo3.Lines.Append('Observatoire = #'+Liste_observatoire[index_obs].Nom+'#')
         { Grer la prise en compte de l'observatoire pour les calculs suivants }

      end;
      if copy(buf,1,3)='OBS' then
      begin
         sub:=copy(buf,5,999);
         Memo3.Lines.Append('Observateur = #'+sub+'#');
      end;
      if copy(buf,1,3)='NET' then
      begin
         repeat
            readln(f,buf);
            if (not eof(f)) and (copy(buf,1,9)<>'----- end') then
            begin
               Mesure.num_mes:=copy(buf,1,5);   { Convertir le premier car. si ncessaire }
               c:=buf[1];
               case c of
               '1'..'9' : val(c,deca,k);
               'A'..'Z' : deca:=ord(c)-ord('A')+10;
               else  deca:=0;
               end;
               val(copy(buf,2,4),numero_obj,k);
               numero_obj:=numero_obj+deca*10000;
               if numero_obj<>0 then
               begin
                  str(numero_obj:6,sub);
                  Memo3.Lines.Append('Objet numrot : '+sub);
               end
               else
               begin
                   Mesure.obj_mes:=copy(Buf,7,2);

                   case buf[6] of
                   'I' : Mesure.obj_mes:='18'+Mesure.obj_mes;
                   'J' : Mesure.obj_mes:='19'+Mesure.obj_mes;
                   'K' : Mesure.obj_mes:='20'+Mesure.obj_mes;
                   'L' : Mesure.obj_mes:='21'+Mesure.obj_mes;
                   ' ' : begin end;
                   end;
                   sub:=Mesure.obj_mes+' '+Copy(buf,9,1)+Copy(buf,12,1)+Copy(buf,10,2);
                   Mesure.obj_mes:=sub;
                   Memo3.Lines.Append('Objet :'+Mesure.obj_mes);
                   { A faire : Traitement d'une ligne de mesure }
               end
            end;
         until (copy(buf,1,9)='----- end') or eof(f);
      end;
   until (copy(buf,1,9)='----- end') or eof(f);
   closefile(f);
end;

procedure TForm1.ButtonCodeTousClick(Sender: TObject);
begin
  if Lecture_Lowell then
  begin
    CheckBoxATEN.Checked:=True;
    CheckBoxAPOLLO.Checked:=True;
    CheckBoxAMOR.Checked:=True;
    CheckBoxCROISEUR.Checked:=True;
    CheckBoxMPC1.Checked:=True;
    CheckBoxMPC2.Checked:=True;
    CheckBoxMPC3.Checked:=True;
    CheckBoxMPC4.Checked:=True;
    CheckBoxMPC5.Checked:=True;
    CheckBoxMPC6.Checked:=True;
    CheckBoxMPC7.Checked:=True;

    CheckBoxLowell5.Checked:=True;
    CheckBoxLowell6.Checked:=True;
    CheckBoxLowell7.Checked:=True;
    CheckBoxLowell8.Checked:=True;
    CheckBoxLowell9.Checked:=True;
    CheckBoxLowell10.Checked:=True;

    CheckBoxSurveyPLS.Checked:=True;
    CheckBoxSurveyT1.Checked:=True;
    CheckBoxSurveyT2.Checked:=True;
    CheckBoxSurveyT3.Checked:=True;
    CheckBoxSurveyUCAS.Checked:=True;

  end;

  if Lecture_MPC then

  begin

    CheckBoxMPCATEN.Checked:=True;

    CheckBoxMPCAPOLLO.Checked:=True;
    CheckBoxMPCAMOR.Checked:=True;
    CheckBoxMPCPlutino.Checked:=True;
    CheckBoxMPCTroyen.Checked:=True;
    CheckBoxMPCCentaure.Checked:=True;
    CheckBoxMPCTNOR.Checked:=True;
    CheckBoxMPCCubewano.Checked:=True;
    CheckBoxMPCPHA.Checked:=True;
    CheckBoxMPCNew.Checked:=True;
    CheckBoxMPCCritique.Checked:=True;
  end;
  SetAppliquerFiltre;

end;

procedure TForm1.ButtonCodeAucunClick(Sender: TObject);
begin
  if Lecture_Lowell then
  begin
    CheckBoxATEN.Checked:=false;
    CheckBoxAPOLLO.Checked:=false;
    CheckBoxAMOR.Checked:=false;
    CheckBoxCROISEUR.Checked:=false;
    CheckBoxMPC1.Checked:=false;
    CheckBoxMPC2.Checked:=false;
    CheckBoxMPC3.Checked:=false;
    CheckBoxMPC4.Checked:=false;
    CheckBoxMPC5.Checked:=false;
    CheckBoxMPC6.Checked:=false;
    CheckBoxMPC7.Checked:=false;

    CheckBoxLowell5.Checked:=false;
    CheckBoxLowell6.Checked:=false;
    CheckBoxLowell7.Checked:=false;
    CheckBoxLowell8.Checked:=false;
    CheckBoxLowell9.Checked:=false;
    CheckBoxLowell10.Checked:=false;

    CheckBoxSurveyPLS.Checked:=false;
    CheckBoxSurveyT1.Checked:=false;
    CheckBoxSurveyT2.Checked:=false;
    CheckBoxSurveyT3.Checked:=false;
    CheckBoxSurveyUCAS.Checked:=false;

  end;
  if Lecture_MPC then
  begin

    CheckBoxMPCATEN.Checked:=False;

    CheckBoxMPCAPOLLO.Checked:=False;
    CheckBoxMPCAMOR.Checked:=False;
    CheckBoxMPCPlutino.Checked:=False;
    CheckBoxMPCTroyen.Checked:=False;
    CheckBoxMPCCentaure.Checked:=False;
    CheckBoxMPCTNOR.Checked:=False;
    CheckBoxMPCCubewano.Checked:=False;
    CheckBoxMPCPHA.Checked:=False;
    CheckBoxMPCNew.Checked:=False;
    CheckBoxMPCCritique.Checked:=False;
  end;
  SetAppliquerFiltre;

end;

procedure TForm1.CheckBoxCodeLowellClick(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxATENClick(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxAPOLLOClick(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxAMORClick(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxCROISEURClick(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxMPC1Click(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxMPC2Click(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxMPC3Click(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxMPC4Click(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxMPC5Click(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxMPC6Click(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxMPC7Click(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxLowell5Click(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxLowell6Click(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxLowell7Click(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxLowell8Click(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxLowell9Click(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxLowell10Click(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxSurveyPLSClick(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxSurveyT1Click(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxSurveyT2Click(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxSurveyT3Click(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxSurveyUCASClick(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.ButtonToutCalculerClick(Sender: TObject);
var
   i,j,code,pas,
   nb_calcul     : integer;
   alphaP,deltaP : real;
   JJEphemDate,TSL,TSL0Greenwich,TSLL,TSLC,TSLM,AngleHoraireP,
   unite_pas     : double;
   Orbite_epoque : T_Date;
   orbite        : T_Orbite;
   positions     : T_position;
   NumeroOrbite  : longint;
   db            : boolean;
   s,sd,sm,buf       : string;
   t             : TextFile;
begin
   {D'abord rcuprer les lments orbitaux de l'astroide :}

   Memo2.Clear;
   db:=false; {CheckBox2.Checked;}
   nb_calcul:=SpinEdit2.Value;
   pas:=SpinEdit3.Value;
   case combobox4.ItemIndex of
   0 : unite_pas:=1.0;
   1 : unite_pas:=1.0/24;
   2 : unite_pas:=1.0/24/60;
   else unite_pas:=1.0;
   end;
   if not db then Memo2.Append('JJ              TSL        Nom              Asc.Dr.Goc. Dclin.Go. Dist.Goc.  Asc.Dr.Topo. Dclin.Topo.  Mag.');
   for i:=1 to taille_liste_filtree+1 do { +1 car la variable taille_liste_filtree est dcrmente lors du filtrage }
   begin
      NumeroOrbite:=Liste_filtree[i];

      With Liste[NumeroOrbite]^ do
      begin
         if db then Memo2.Append('Calcul d''Ephemerides de '+Nom);
         if db then Memo2.Append(' ');

         Val(Copy(Epoque,1,2),Orbite_epoque.Jour,code);
         Val(Copy(Epoque,4,2),Orbite_epoque.Mois,code);
         Val(Copy(Epoque,7,4),Orbite_epoque.Annee,code);
         Orbite.JJEpoque:=JJ(Orbite_epoque);
         Val(DGA,Orbite.DemiAxe,code);
         Val(AnomMoy,Orbite.AnomMoy,code);
         Val(ArgPer ,Orbite.ArgPer ,Code);
         Val(LongNod,Orbite.LongNod,Code);
         Val(Inclin ,Orbite.Inclin ,code);
         Val(Excent ,Orbite.Excent ,code);
         Val(H,Orbite.H,code);
         Val(G,Orbite.G,code);
         With orbite do
         begin
            AnomMoy:=AnomMoy/180*Pi;
            ArgPer:=ArgPer/180*Pi;
            LongNod:=LongNod/180*Pi;
            Inclin:=inclin/180*Pi;
         end;
      end;

      with ephem_date do
      begin
         Val(CB_jour.Text,jour,code);
         annee:=SE_annee.value;
         Mois:=CB_mois.ItemIndex+1;
         heure:=SE_heure.Value+SE_minute.Value/60;
         JJEphemDate:=JJ(Ephem_date)+heure/24;
         str(Orbite.JJEpoque:12:3,s);
         if db then Memo2.Append('Jour Julien Epoque de l''orbite  : '+s);
      end;

      for j:=1 to nb_calcul do
      begin
         str(JJEphemDate:12:3,s);
         if db then Memo2.Append('Jour Julien Instant de calcul   : '+s);

         calcul_ephemerides(JJEphemDate,db,orbite,positions);

         {Rcupration des messages gnrs lors du calcul de la position  : }

         AssignFile(t,'ephem.log');
         Reset(t);
         repeat
            readln(t,s);
            if s<>'' then Memo2.Append(s);
         until eof(t);
         BSaveLog.Enabled:=True;
         closeFile(t);

         with Positions do
         begin
            Str(Dist_T:11:8,s);
            Str(JJEphemDate:13:5,sd);
            TSL0Greenwich:=Temps_Sideral_Greenwich_0h(JJEphemDate);
            {TSL0Greenwich:=Modulo(TSL0Greenwich,2*Pi);}
            TSL:=Temps_Sideral_Local(JJEphemDate,Observatoire.Longitude*180/pi);
            {TSL:=Modulo(TSL,2*Pi);}
            Topocentrique(positions,observatoire,TSL,AlphaP,DeltaP);

            AngleHoraireP:=TSL-AlphaP;
            if angleHoraireP<0 then angleHoraireP:=AngleHoraireP+2*pi;
            Lever(AlphaP,DeltaP,observatoire,TSLL,TSLC,TSLM);
            if Magnitude<30 then Str(Magnitude:5:2,sm) else sm:='--.--';

            if db then
            begin
               Memo2.Append('Position de '+Liste[NumeroOrbite]^.nom);
               Memo2.Append('Ascension Droite               : '+StringHMS(Alpha*12/pi,'hms'));
               Memo2.Append('Dclinaison                    : '+StringHMS(Delta*180/pi,'''"'));
               Memo2.Append('Distance  la Terre            :   '+s+' UA');
               Memo2.Append('');
               Memo2.Append('Longitude                      : ');
               Memo2.Append('Temps sideral Greenwich 0h     : '+StringHMS(TSL0Greenwich*12/Pi,'hms'));
               Memo2.Append('Temps sideral local            : '+StringHMS(TSL*12/Pi,'hms'));
               Memo2.Append('Angle Horaire topocentrique    : '+StringHMS(AngleHoraireP/Pi*12,'hms'));
               Memo2.Append('Ascension droite topocentrique : '+stringHMS(AlphaP/pi*12,'hms'));
               Memo2.Append('Dclinaison topocentrique      : '+stringHMS(DeltaP/pi*180,'ms'));
               Memo2.Append('Magnitude                      : '+sm);
            end
            else
            begin
               buf:=sd+' '+StringHMS(TSL,'hms')+' '+Copy(Liste[NumeroOrbite]^.nom,1,15)+' '+StringHMS(Alpha*12/pi,'hms')
                            +' '+StringHMS(Delta*180/pi,'''"')+' '+s+' '+StringHMS(AlphaP*12/pi,'hms')+' '+StringHMS(Delta*180/pi,'''"')+' '+sm;
               Memo2.Append(buf);
            end;

         end;
         JJEphemDate:=JJEphemDate+pas*unite_pas;
      end;
   end;
end;

procedure TForm1.CheckBoxMPCAtenClick(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxMPCApolloClick(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxMPCAmorClick(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxMPCPlutinoClick(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxMPCTroyenClick(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxMPCCentaureClick(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxMPCTNORClick(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxMPCCubewanoClick(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxMPCPHAClick(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxMPCNewClick(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxMPCCritiqueClick(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.CheckBoxCodeMPCClick(Sender: TObject);
begin
   SetAppliquerFiltre;
end;

procedure TForm1.ButtonHTTPMPCClick(Sender: TObject);
begin
    If Combobox1.ItemIndex>-1 then Form3.MPC_fichier:=Combobox1.Items[Combobox1.Itemindex] else
       Form3.MPC_fichier:=Combobox1.Items[0];
    DemandeChargement:=DemandeChargementMPC;
    Form3.Show;
end;


end.



