unit decoupe;

interface

{Module de dcoupe de phrase en mots spar par des blancs}
const
   max_mot = 50;
type
   t_phrase = array[1..max_mot] of string[40];


procedure decouper(buffer : string;sep : char;  var mot : t_phrase);
// function trim(ch : string) : string;

implementation
{
function trim(ch : string): string;
var
   s   : string;
   i,l : integer;
begin
   i:=0;
   s:='';
   l:=length(ch);
   if l>0 then
   begin
      repeat
         inc(i);
      until (i=l) or (ch[i]<>' ');
      if (i<=l) then s:=copy(ch,i,l-i+1);

      l:=length(s);
      if l>0 then
         while s[l]=' ' do
         begin
            s:=copy(s,1,l-1);
            l:=length(s);
         end;
   end;
   trim:=s;
end;
}
procedure decouper(buffer : string;sep : char;  var mot : t_phrase);
var
   i,j,l : integer;
begin

   for j:=1 to max_mot do mot[j]:='';

   i:=1;
   j:=0;
   l:=length(buffer);

   if l>0 then
   begin
      if buffer[i]=sep then
      repeat
         inc(i);
      until (buffer[i]<>sep) or (i>l); { On passe les blancs de tete }
      if i<=l then
      begin
         repeat
            if buffer[i]=sep then
            begin
               if buffer[i-1]<>sep then inc(j);
               i:=i+1
            end
            else
            begin
               if j=0 then j:=1;
               mot[j]:=mot[j]+buffer[i];
               inc(i);
            end

         until i>length(buffer);
      end;
   end;
end;

begin
end.